﻿/* Generated with Author-it 5.5.264.13693  12/28/2015 10:31:52 AM */
Page=new Array();Page[0]=new Array("About Plesk Extensions","A Plesk extension, as the name suggests, is a third-party software that adds new functionality to Plesk. The former name of Plesk extensions is modules. Typical examples of extensions are help desk and ticket system solutions. On one hand, these solutions access information about Plesk entities, particularly, user accounts, and on the other hand they provide their own tools to help administrators and customers communicate with each other. ","Extensions are written in PHP and their organization reuses Zend framework practices to a large extent, for example, the implementation of MVC and forms construction. Using these practices is recommended, but is not required. Because PHP is mandatory for writing extensions, we assume that the readers of this document have knowledge of the programming language. If you haven't written PHP applications before, you can still use the document, but you might need to read some PHP-specific topics (which are beyond the document scope) to develop the extension you need.","How to Create and Install Extensions","A ready for distribution extension is a ZIP archive which contains a specifically-organized directory structure and a file with meta information describing the software. A fast way to create an extension is to call the extension command-line utility (extension --create &lt;EXTENSION_NAME&gt;). This call will create the necessary file structure. Read more about organization of extension files in Extension Structure.","Extensions are normally installed by the administrator in Plesk, in Server Management &gt; Extensions (in the left navigation menu).","Extensions Management Utility","The extension command-line utility enables you to manage extensions through the command-line interface, including installation or removing of extensions, packing the source files of an extension into a ZIP archive ready for distribution, and generating an extension template. Learn how to use the extensions utility.","Get Started with Extensions Development","The most rapid way to start developing extensions is to read the Quick Start chapter. This chapter guides you through the process of developing simple extensions and provides concrete examples of using Plesk features in combination with conceptual information and best practices of how to work with the SDK. ","Extension Examples","We provide examples of implementation of certain extensions, such as RSS news or requests tracking system. You can learn from the examples and use their code when developing custom extensions for Plesk. Learn more. ","API Stubs","For quicker development, you can use API stubs for IDE, which are available at https://github.com/plesk/pm-api-stubs. Download the files and add them to your IDE. For example, if you use PhpStorm, go to Project Settings &gt; PHP and add the directory with the downloaded files in Include Path. ","Plesk Features Available to Extensions","An extension can receive information about Plesk entities, react to different system events, and do even more through Plesk interfaces. The full list of available interfaces is as follows: ","Getting user and domain data.","This interface enables extensions to retrieve information about Plesk users and hosted domains. Particularly, this interface can be used for establishing context of the user currently logged in to Plesk and the domain that is open in the Control Panel. Learn how to use this interface.","XML API.","This interface allows extensions to get administrative control over Plesk entities and manage them by exchanging operation requests wrapped into XML-structured packets. Plesk receives such an XML-structured operation request, processes it, and responds with a PHP class whose fields mimic the XML tree structure. A Plesk response includes an operation status and operation-related details. For example, if you request information about a customer account, the account details will be returned. Read how to use this interface.","Command-line interface (CLI).","This interface allows extensions to perform operations on Plesk objects from the command line on behalf of the administrator. Read how to use this interface.","Key-value storage.","Extensions can put some of their persistent data, for example, their settings in the key-value storage (provided by Plesk) and then easily get the data on demand. Read how to use this interface.","Event handlers.","This interface lets extensions subscribe to a particular Plesk event and trigger a particular action depending on the event information. Read how to use this interface.","Scheduled tasks.","Using this interface, extensions can run periodic tasks, for example, to collect daily statistics or analyze data. Read how to use this interface.","Rendering UI elements.","This interface offers means of generating UI elements, such as links, lists, messages, buttons, and tabs, by using controller and view helpers. Read how to use this interface. ","File manager.","Using this interface, extensions can read and edit files and directories on the server and extend the Plesk File Manager's functionality. Read how to use this interface.","Home widget.","Using this interface, extensions can advertise themselves by adding promotional blocks to the Administrator's dashboard (the Home page). Read how to use this interface.","Global JavaScript and CSS files.","Using these files, extensions can adjust the functionality and appearance of existing Plesk pages, all at once or only selected ones. Read how to use this interface.","Content include hook.","This interface provides a way to generate HTML or JavaScript code to be included into Plesk pages. Read how to use this interface. ","Authentication hook.","Using this hook, extensions can check user credentials in an external system. Read how to use this interface. ","Custom buttons.","Plesk provides an easy way to add custom buttons related to an extension. Read how to use this interface. ","Localization.","Extensions can automatically display their messages in the language selected in Plesk. Read how to use this interface.<br>","Mail handlers.","This interface allows invocation of custom mail handlers at various stages of mail processing by the Mail Transfer Agent (MTA) to manage incoming, outgoing, and pass-through mail. Read how to use this interface.<br>","Third-party DNS.","Plesk provides the option to use external third-party DNS servers to resolve domain names of websites hosted on the Plesk server. Read how to use this interface. ","Slave DNS server.","Plesk provides means of integrating Plesk with an external Linux-based slave DNS server. Read how to use this interface. ","Testing Extensions","In order to test an extension, you should install it to Plesk. To provide you with more debugging information, we recommend that you increase the verbosity of the debugging information in Plesk. Learn how to test extensions.","Resources and Further Learning","This document covers only the basic functionality that the SDK provides. To view a complete list of Plesk tools that an extension can use, read the auto-generated Reference document and review the extension samples. ","Additionally, for learning purposes, you can use existing Plesk extensions available on our GitHub page. See also the Extension Examples section of this guide.","&nbsp;&nbsp;","Introduction","about.htm");
Page[1]=new Array("This tutorial on writing extensions gives you a hands-on introduction to the Plesk extensions SDK. Starting from specially-prepared code, it guides you through the process of developing a typical extension with the GUI, a simple news feed reader, and, finally, the extension which displays usage statistics.","Each exercise consists of several steps. You should follow the steps to gradually create and refine your extension. The exercises explain each step in detail and provide all the sample code you need to complete the extension.","After you complete the tutorial, you will learn many of the most important concepts in extensions development. If you want to add more complex features to your extensions, examine the extensions SDK reference. ","Preparing for the Exercises","To prepare for the exercises, browse our GitHub page. You should see six subdirectories: ex1, ex2, ex3, ex1complete, ex2complete, and ex3complete. The ex# directories are the starting points for each of the exercises, while the ex#complete directories are completed exercises. If you are having trouble with a particular exercise, you can compare your current work against the completed variant.","Unless otherwise stated, directory paths in the following exercises are given relatively to the root directory of an extension (which is the contents of ex# or ex#complete).","Exercises","The table below lists the tutorial exercises and describes the development areas that each covers. Exercises do not depend on each other; you can complete them in an arbitrary order.","Exercise 1. Tabs, Forms, Lists, Tools","Construct tabs, add a form, add an items list, and add a few buttons to the toolbar. Demonstrates the basics of creating the most popular GUI elements.","Exercise 2. Task Scheduling and Dashboard Integration","Add a scheduled task and a dashboard widget. Demonstrates integration with the Plesk scheduling interface and Dashboard (the Home page).","Exercise 3. Working with Plesk Objects","Get usage statistics using the XML API interface. Demonstrates how to work with XML API and pass control directly to PHP scripts.","Quick Start","71006.htm");
Page[2]=new Array("In this exercise, you will construct a simple tabbed web interface integrated into Plesk. The first tab will contain a form, the second will contain a list of items, and the third - a toolbox with two actions. The exercise demonstrates the basics of building into the Plesk GUI.","We assume that the extension ID is example, and that you start with the code inside the ex1 directory. This code is partly written by us to help you focus only on certain areas. Additionally, we have populated the directory with media content necessary for the exercise. To see the completed exercise, examine the ex1complete directory.","Step 1. Obtain the control flow from Plesk.","Each extension has a single index file that is executed first when a user navigates to the extension from Plesk (for example, when the administrator goes to Server Management &gt; Extensions and clicks the extension name). This index file is called index.php and its path is /htdocs/index.php relatively to the extension's root directory. From this start point, you can either write your own code which renders the GUI in its own way, or use facilities for rapid extensions development that the SDK provides.","One of these facilities is support for the MVC pattern. If you are unfamiliar with the pattern, please read http://framework.zend.com/manual/1.11/en/learning.quickstart.intro.html. Applied to our example, the first thing we need to do is to select an appropriate class for further processing of the request to the index.php. Edit the file so that it looks as follows:","&lt;?php","$application = new pm_Application();","$application-&gt;run();","These two lines tell the system to load helpers for drawing the GUI elements, load controllers, and pass the control to the default controller for requests processing (which is in /plib/controllers/IndexController.php under the extension's root directory). ","If we open IndexController.php, we will see that it extends pm_Controller_Action. It is mandatory that you use this class or its extensions for controllers. ","As you can also see, this class has method stubs, for example, formAction. This method will be called when calling the following URL: ","http://&lt;plesk-host-name&gt;:&lt;port&gt;/modules/&lt;extension id&gt;/index.php/index/form.","So the relations between requested URLs and methods can be represented this way:","URL prefix after /index.php/","Controller name ","Method to call","index/form","IndexController","formAction","index/tools","IndexController","toolsAction","custom/call","CustomController","callAction","In other words, the system processes request URLs, finds the &lt;controller name&gt;/&lt;action name&gt; pair and passes the control flow to the corresponding method. This mapping scheme comes from Zend, read more about it at http://framework.zend.com/manual/1.11/en/zend.controller.action.html. ","Summing up, to draw the first GUI your users will see, we need to implement the indexAction method of IndexController. However, as we are going to have a form in the first tab, we need to forward requests from indexAction to formAction. To allow for the forwarding, change indexAction so that it looks as follows:","    public function indexAction()","    {","        // Default action will be formAction","        $this-&gt;_forward('form');","    }","We used the _forward Zend method for this purpose. Now all requests to the extension's index successfully reach formAction.","Step 2. Add a tabbed view.","Currently, we are in IndexController.php and we are about to add tabs to the extension. Instead of adding the tabs definition code to each action (for the form, list, and toolbar), we can specify the tabs once in the init() method and avoid code duplication. The init() method runs before action methods. Change the method so that it looks as follows:","    public function init()","    {","        parent::init();","        // Init title for all actions","        $this-&gt;view-&gt;pageTitle = 'Example Extension';","        // Init tabs for all actions","        $this-&gt;view-&gt;tabs = array(","            array(","                'title' =&gt; 'Form',","                'action' =&gt; 'form',","            ),","            array(","                'title' =&gt; 'Tools',","                'action' =&gt; 'tools',","            ),","            array(","                'title' =&gt; 'List',","                'action' =&gt; 'list',","            ),","        );","    }","As you can see, $this-&gt;view-&gt;tabs array binds the controller actions to tabs. Loosely speaking, now when a user navigates to the List tab, the system will trigger the listAction method.","Finally, define the presentation of our default tab, or, in other words, write its view. Read more about views at http://framework.zend.com/manual/1.11/en/zend.view.introduction.html. The views must be kept the /plib/views/scripts/&lt;controller name&gt;/&lt;action name&gt;.phtml inside the extension's root directory. Since form is the default tab, we will need to edit  /plib/views/scripts/index/form.phtml. Add the following line to form.phtml:","&lt;?php echo $this-&gt;renderTabs($this-&gt;tabs); ?&gt;","The renderTabs method should render the tabs. The rendered view will natively be built into the Plesk web interface.  ","Great, now we have the tabs, now let's add some information into them.","Step 3. Add a form.","As defined in the tabs array we created before, our form is mapped with the formAction() method, so, according to MVC, we need to create a form instance in this method and render it in the form.phtml view. ","Regarding form construction, we rely on the Zend framework. If you are unfamiliar with Zend forms, read http://framework.zend.com/manual/1.11/en/zend.form.quickstart.html . The basic idea behind forms is that a form must be the pm_Form_Simple PHP class or its extension. You can add input fields and buttons to a form by calling its addElement (Zend method) and addControlButtons (the SDK method). The benefit of this approach is that form validation and HTML rendering is done for you.","The form construction code is too long to present it here, refer to IndexController.php, formAction() to view it. As you can see in formAction(), after adding form elements, the code passes the form to the view as a variable.","$this-&gt;view-&gt;form = $form;","Render the form by adding the following line to /plib/views/scripts/index/form.phtml:","&lt;?php echo $this-&gt;form; ?&gt;","Step 4. Add a list.","Similar to forms, we need to create a list instance in listAction() and then render it in /plib/views/scripts/index/list.phtml. The list instance must be the pm_View_List_Simple class or its extension. Learn how to create a list from the code in IndexController.php, _getNumbersList(). The _getNumbersList() method generates a two-column list with some content. ","Here are the most important steps of lists creation:","Add the list data as an associative array.","Create a list as a pm_View_List_Simple  instance and specify the view and request parameters in the constructor.","Add the data to the list by using the setData method.","Define the list columns by the setColumns method. The column names in your data array and in setColumns must match.","Specify the list action URL using setDataUrl. This URL is actually the resource which is requested when a user performs operations with list controls (for example, when a user decides to change a page or an order). In our example, this URL is list-data. When a user requests http://&lt;plesk host name&gt;:&lt;port&gt;/modules/example/index.php/index/list-data, the system transforms hyphens to camel case and actually requests the listDataAction method of IndexController.","Below is an example of the code that creates a list object:","    private function _getNumbersList()","    {","        $data = array();","        $iconPath = pm_Context::getBaseUrl() . 'images/icon_16.gif';","        for ($index = 1; $index &lt; 150; $index++) {","            $data[] = array(","                'column-1' =&gt; '&lt;a href=&quot;#&quot;&gt;link #' . $index . '&lt;/a&gt;',","                'column-2' =&gt; '&lt;img src=&quot;' . $iconPath . '&quot; /&gt; image #' . $index,","            );","        }","        $list = new pm_View_List_Simple($this-&gt;view, $this-&gt;_request);","        $list-&gt;setData($data);","        $list-&gt;setColumns(array(","            'column-1' =&gt; array(","                'title' =&gt; 'Link',","                'noEscape' =&gt; true,","                'searchable' =&gt; true,","            ),","            'column-2' =&gt; array(","                'title' =&gt; 'Description',","                'noEscape' =&gt; true,","                'sortable' =&gt; false,","            ),","        ));","        // Take into account listDataAction corresponds to the URL /list-data/","        $list-&gt;setDataUrl(array('action' =&gt; 'list-data'));","        return $list;","    }","Now when you have the list, pass it to the view by changing listAction() to look the following way:","    public function listAction()","    {","        $list = $this-&gt;_getNumbersList();","        // List object for pm_View_Helper_RenderList","        $this-&gt;view-&gt;list = $list;","    }","The next important step is to change listDataAction() to handle changes in page numbers and results order.","    public function listDataAction()","    {","        $list = $this-&gt;_getNumbersList();","        // Json data from pm_View_List_Simple","        $this-&gt;_helper-&gt;json($list-&gt;fetchData());","    }","After you add these lines, the list paging and ordering will be self-serviced by the system.","Finally, render the tabs and the list by adding the following lines to /plib/views/scripts/index/list.phtml:","&lt;?php echo $this-&gt;renderTabs($this-&gt;tabs); ?&gt;","&lt;?php echo $this-&gt;renderList($this-&gt;list); ?&gt;","As you can see, renderList fetches the list instance and transforms it into HTML.","In addition, it is possible to implement group operations. For example:","&nbsp; &nbsp; &nbsp; &nbsp;$list-&gt;setColumns([","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;pm_View_List_Simple::COLUMN_SELECTION,","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;'column-1' =&gt; array(","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;'title' =&gt; &#8216;MyTest',","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;),","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;]);","&nbsp; &nbsp; &nbsp; &nbsp; $list-&gt;setTools([","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; [","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 'title' =&gt; 'Hide',","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 'description' =&gt; 'Make selected rows invisible.',","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 'class' =&gt; 'sb-make-invisible',","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 'execGroupOperation' =&gt; [","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 'submitHandler' =&gt; 'function(url, ids) {","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; $A(ids).each(function(id) {","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; $(&quot;' . $list-&gt;getId() . '&quot;)","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; .select(&quot;[name=\\'listCheckbox[]\\'][value=\\'&quot; + id.value + &quot;\\']&quot;)","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; .first()","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; .up(&quot;tr&quot;)","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; .hide();","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; });","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }'","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ],","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ], [","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 'title' =&gt; 'Remove',","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 'description' =&gt; 'Remove selected rows.',","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 'class' =&gt; 'sb-remove-selected',","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 'execGroupOperation' =&gt; $this-&gt;_helper-&gt;url('remove'),","&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ],","&nbsp; &nbsp; &nbsp; &nbsp; ]);","&nbsp;","It is also possible to specify the default column for sorting via the options on creation of a pm_View_List_Simple class object.","&nbsp; &nbsp; $options = [","&nbsp; &nbsp; &nbsp; &nbsp; 'defaultSortField' =&gt; 'column-1',","&nbsp; &nbsp; &nbsp; &nbsp; 'defaultSortDirection' =&gt; pm_View_List_Simple::SORT_DIR_DOWN,","&nbsp; &nbsp; ];","&nbsp; &nbsp; $list = new pm_View_List_Simple($this-&gt;view, $this-&gt;_request, $options);","Step 5. Add a toolbar.","Let's add a toolbar with two buttons to the third tab. For this, change the toolsAction() method in IndexController.php to look as follows:","    public function toolsAction()","    {","        // Tools for pm_View_Helper_RenderTools","        $this-&gt;view-&gt;tools = array(","            array(","                'icon' =&gt; pm_Context::getBaseUrl() . &quot;img/site-aps_32.gif&quot;,","                'title' =&gt; 'Example',","                'description' =&gt; 'Example extension with UI samples',","                'link' =&gt; pm_Context::getBaseUrl(),","            ),","            array(","                'icon' =&gt; pm_Context::getBaseUrl() . &quot;img/modules_32.gif&quot;,","                'title' =&gt; 'Extensions',","                'description' =&gt; 'Extensions installed in Plesk',","                'link' =&gt; pm_Context::getModulesListUrl(),","            ),","        );","    }","The code demonstrates that to add a toolbar item, you should specify its properties - icon, title, description, and link. Here we use the context to generate link URLs. Be sure to initialize the context before using it. We did this in the very beginning, at step 1. Another thing to note is that pm_Context::getBaseUrl() generates the path to the /htdocs directory of the extension. In our example, the first icon will be retrieved from /htdocs/img/site-aps_32.gif","Once the toolbar is ready, render it together with tabs by adding the following lines to  /plib/views/scripts/index/tools.phtml:","&lt;?php echo $this-&gt;renderTabs($this-&gt;tabs); ?&gt;","&lt;?php echo $this-&gt;renderTools($this-&gt;tools); ?&gt;","The renderTools method will render the toolbar to HTML.","Congratulations! You are almost done with Exercise 1, the only thing left is to add the extension description.","Step 6. Describe the extension.","You have the meta.xml file in the extension's root directory. This file contains information about your extension which is visible to Plesk administrators after they install the extension to the system. Feel free to change it according to your needs (keep in mind that the extension ID in your code and description must match).  ","Step 7. Install and test the extension.","Congratulations! You have completed the exercise. To install your extension to Plesk: ","Add the contents of the ex1 directory (not the directory itself) to a ZIP archive using your favorite software. ","Important: Ensure that meta.xml resides in the root of the unpacked archive. This is a very important requirement, otherwise Plesk will return an error on adding your extension to Plesk.","Log in to Plesk as the administrator and add the extension on the Server Management &gt; Extensions page.","You should see your extension in the list. Click its name to see the tabs we've created in Exercise 1. You can use the completed extension available here for reference.","Exercise 1. Tabs, Forms, Lists, Tools","71032.htm");
Page[3]=new Array("In this exercise, you will create a simple RSS reader which displays the last feed item from the Odin feed on the administrator's dashboard. While writing the extension, you will learn how to do the following: ","Write installation and removal scripts.","Use the key-value storage.","Add scheduled tasks.","Create promotional blocks on the administrator's dashboard.","We assume that the extension ID is plesk-news, and that you start with the code inside the ex2 directory. This code is partly written by us to help you focus only on certain areas. Additionally, we have populated the directory with media content necessary for the exercise. To see the completed exercise, examine the ex2complete directory.","Step 1. Populate the storage with the last feed item.","The extension we are going to write will not have its own GUI. Instead, all its functions will be available from the promo block on the administrator's Home page. That is why we do not need to get the control flow as we did in Exercise 1, step 1. However, we need to populate the extension's storage with the last feed item. For this, we should write a script that fetches the item and saves it directly after the installation of our extension. ","The extensions SDK provides the ability to run PHP scripts in this and some other situations. The following table summarizes which extension files are called in particular conditions.","File","Condition","/plib/scripts/pre-install.php","Before installing an extension","/plib/scripts/post-install.php","After installing an extension","/plib/scripts/pre-uninstall.php","Before an extension removal","So the system scans each extension for these scripts and runs the scripts as needed.","In our exercise, we are interested in fetching the feed item after the installation, so you should change /plib/scripts/post-install.php by adding the following lines to the file:","pm_Context::init('plesk-news');","Modules_PanelNews_News::load();","The first line loads the extension's context. We will use it next to interact with the key-value storage. The next line calls the method which fetches the feed item. We are going to use this method more than in one place, so we isolated it into a separate class. ","&nbsp;","As you might have noticed that we didn't require Modules_PanelNews_News in post-install.php. This happened because it was loaded automatically. For auto-loading we rely on the Zend approach. Read more about it in http://framework.zend.com/manual/1.11/en/learning.autoloading.design.html. ","Applied to our class, the system performs the following sequence of operations:","The Modules_ prefix tells the system that a class should be inside an extension.","The PanelNews_ part is transformed to the extension ID by adding dashes before capitals and moving capitals to the lower case. After the transformation, the resulting ID is plesk-news.","Finally, News part tells the system to seek the class definition in News.php inside the /plib/library directory of our extension.","Knowing this strategy, you can write your own classes, put them in the /plib/library directory, and later use them in your code without requiring them first.","Returning to the load method implementation, open the /plib/library/News.php and change load to the following:","    public static function load()","    {","        $xml = simplexml_load_file('http://odin.com/products/plesk/rss');","        $lastItem = $xml-&gt;channel-&gt;item;","        pm_Settings::set('news_text', (string) $lastItem-&gt;title);","        pm_Settings::set('news_link', (string) $lastItem-&gt;link);","    }","The code demonstrates how the feed item is saved to the storage using pm_Settings::set by assigning the news_text and news_link variables. Now you can get the variable values at any time with pm_Settings::get if the extension's context is initialized.","Step 2. Display the feed item in the promo block.","To create a promotional block in Plesk, add the following lines to /plib/library/Promo/Home.php:","class Modules_PanelNews_Promo_Home extends pm_Promo_Home","{","    public function getTitle()","    {","        return 'Plesk News';","    }","    public function getText()","    {","        pm_Context::init($this-&gt;_moduleId);","        return pm_Settings::get('news_text');","    }","    public function getButtonText()","    {","        return 'View Article';","    }","    public function getButtonUrl()","    {","        return pm_Settings::get('news_link');","    }","    public function getIconUrl()","    {","        pm_Context::init('plesk-news');","        return pm_Context::getBaseUrl() . '/images/feed.png';","    }","} ","As you can see, this class describes a promo block. It is not called from anywhere inside the extension itself. In fact, the system loads all classes which extend  pm_Promo_Home automatically when the Plesk administrator loads the Home page. To be loaded, the class name should adhere to the naming convention we discussed at step 1. If you package the extension and add it to Plesk, you will see the following new block on the dashboard.","When the administrator clicks the link, they will be forwarded to the news_link variable from the key-value storage. We do two init calls in the Modules_PanelNews_Promo_Home code to be sure that the storage is initialized before it is used.","Step 3. Schedule the periodic update of the last feed item","The variable news_link is assigned only once, particularly, when the extension is installed. We need to update its value periodically to follow the Odin feed. For this, we will run a scheduled script, but first let's create the script itself. ","Note: It is mandatory to keep scheduled scripts under /plib/scripts.","Assume our script name periodic-task.php, so its path within the extension will be /plib/scripts/periodic-task.php. Open the file and add the following code to it:","pm_Context::init('plesk-news');","Modules_PanelNews_News::load();","&nbsp;","Looks familiar? Yes, we used the same code in post-install.php. Now it's time to schedule the script run. The best place for this is the post-installation script to ensure that the task is safely scheduled just right after the installation of our extension. Open /plib/scripts/post-install.php and refine it to look as follows:","&lt;?php","pm_Context::init('plesk-news');","$task = new pm_Scheduler_Task();","$task-&gt;setSchedule(pm_Scheduler::$EVERY_DAY);","$task-&gt;setCmd('periodic-task.php');","pm_Scheduler::getInstance()-&gt;putTask($task);","pm_Settings::set('periodic_task_id', $task-&gt;getId());","Modules_PanelNews_News::load();","&nbsp;","The code demonstrates that to schedule a script run (so-called task), we need to create an instance of pm_Scheduler_Task, set its period by setSchedule, define a target script by setCmd. Finally, add the task the schedule interface by putTask.","We also need to securely remove the task when removing the extension, so we save the task ID to the periodic_task_id variable. For the same reason, you should add the following lines to /plib/scripts/post-uninstall.php:","pm_Context::init('plesk-news');","$taskId = pm_Settings::get('periodic_task_id');","$task = pm_Scheduler::getInstance()-&gt;getTaskById($taskId);","pm_Scheduler::getInstance()-&gt;removeTask($task);","This code will remove the task from the schedule interface.","Step 4. Install and test the extension.","Congratulations! You have completed the exercise. To install your extension to Plesk: ","Add the contents of the ex2 directory (not the directory itself) to a ZIP archive using your favorite software. ","Important: Ensure that meta.xml resides in the root of the unpacked archive. This is a very important requirement, otherwise Plesk will return an error on adding your extension to Plesk.","Log in to Plesk as the administrator and add the extension on the Server Management &gt; Extensions page. ","You should see your extension in the list. It is dimmed because it does not have its own GUI, but you can see it on the Home page.","Exercise 2. Task Scheduling and Dashboard Integration","71062.htm");
Page[4]=new Array("This exercise will guide you through creating an extension that reports the number of customer accounts, websites, databases, and mail accounts on a Plesk server; the output format will be a plain text or the text in XML or JSON. While writing the extension, you will learn how to do the following: ","Use custom authentication (call PHP files bypassing controllers).","Access Plesk entities through XML API.","We assume that the extension ID is plesk-stats, and that you start with the code inside the ex3 directory. This code is partly written by us to help you focus only on certain areas. Additionally, we have populated the directory with media content necessary for the exercise. To see the completed exercise, examine the ex2complete directory.","Step 1. Set up custom authentication.","The extension we are going to write will consist of the form which the administrators will use to set up the data output format, and the endpoint form where users will request the statistics. As the statistics is secure data, we should set up access control to deliver the results only to certain users. The two ways on how to do this are possible: ","Determine the user type - administrator, reseller, or customer and restrict access basing on this type. This is accomplished by creating the pm_Session class instance and using its boolean methods isClient(), isReseller(), isAdmin().","$session = new pm_Session();","$client = $session-&gt;getClient();","if ($client-&gt;isAdmin()) {","}","Write your own authentication method.","As we assume that the statistics web service will be used by third-party applications, we will write a custom authentication method.","Start with defining a secret token authToken in our post-installation script and saving it to the key-value storage. For this, append the following two lines to /plib/scripts/post-install.php:","pm_Settings::set('useAuth', true);","pm_Settings::set('authToken', md5(uniqid(rand(), true)));","If you are new to installation scripts and working with key-values storage, we recommend that you read Exercise 2. ","Next, add a form that defines the output method. Nothing new here, we have already explained how to do it by writing appropriate controllers, actions, and views in Exercise 1, so we have added all the necessary code for you. If you are curious, see the following files:","/htdocs/index.php","/plib/controllers/IndexController.php","/plib/library/Form/Settings.php","/plib/views/scripts/index/index.phtml","One thing about the form worth noting here: Among other fields, the form includes links to the statistics. These links navigate to /public/?authToken=$authToken under the extension's web root directory. The web /public is associated with the /htdocs/public directory of an extension. This is a special directory. If someone requests a resource from this directory, the control will be passed directly to the resource bypassing controllers. In our example, if we want to have a public endpoint, we need to create a script inside this directory and tell the service consumers the script URL.","To control the statistics requests to /public, add the following lines to /htdocs/public/index.php:","if (pm_Settings::get('useAuth') &amp;&amp; @$_GET['authToken'] != pm_Settings::get('authToken')) {","    die('Invalid auth token supplied.');","}","The code compares the token from the storage and the token in request. If they do not match, the script execution is stopped.","Great, now you have the authentication system, let's add some statistics to the  /htdocs/public/index.php output.","Step 2. Retrieve information about Plesk entities.","The extension will use the Modules_PanelStats_Reporter class to communicate with XML API. The class is already defined it requires only an XML API call. Open /plib/library/Reporter.php and change the class constructor to request the required statistics:","$request = '&lt;server&gt;&lt;get&gt;&lt;stat/&gt;&lt;/get&gt;&lt;/server&gt;';","$this-&gt;_stats = pm_ApiRpc::getService()-&gt;call($request)-&gt;server-&gt;get-&gt;result-&gt;stat-&gt;objects;","The description of the operation the code requests is available here.","The response description is available here.","According to the manual, the _stats class field contains the nodes described here.","The pre-written methods of Modules_PanelStats_Reporter facilitate processing of the response data. The getResultsXml method returns the data as an XML tree, the getResultsJson returns the result in the JSON format, and getResultsPlain returns the information in the plain text. Now we need to provide this information to the extension users.","Step 3. Provide the statistics to the extension users.","As discussed at step 1, end users will request /htdocs/public/index.php for the statistics, and this file currently has the access control implemented. To provide the statistics, change the file so that it looks as follows:","&lt;?php","require_once('sdk.php');","pm_Context::init('plesk-stats');","if (pm_Settings::get('useAuth') &amp;&amp; @$_GET['authToken'] != pm_Settings::get('authToken')) {","    die('Invalid auth token supplied.');","}","$reporter = new Modules_PanelStats_Reporter();","$format = isset($_GET['format']) ? $_GET['format'] : 'xml';","if ('plain' == $format) {","    echo $reporter-&gt;getResultsPlain();","} else if ('json' == $format) {","    header(&quot;Content-Type: application/json&quot;);","    echo $reporter-&gt;getResultsJson();","} else {","    header(&quot;Content-Type: text/xml&quot;);","    echo $reporter-&gt;getResultsXml();","}","Comparing to the previous version of the file, this version creates the Modules_PanelStats_Reporter instance and provides the statistics depending on the format GET argument. ","You may have noticed that the code starts with the following line:","require_once('sdk.php');","Important: This line is required to set up classes auto-loading in this script, as the auto-loading feature does not work in /htdocs/public by default.","Step 4. Install and test the extension.","Congratulations! You have completed the exercise. To install your extension to Plesk: ","Add the contents of the ex3 directory (not the directory itself) to a ZIP archive using your favorite software. ","Important: Ensure that meta.xml resides in the root of the unpacked archive. This is a very important requirement, otherwise Plesk will return an error on adding your extension to Plesk.","Log in to Plesk as the administrator and add the extension on the Server Management &gt; Extensions page. ","You should see your extension in the list, set up the extension settings and follow the links in the form to see Plesk statistics in different formats.","Exercise 3. Plesk Entities and Authentication","71072.htm");
Page[5]=new Array("Starting from Plesk 11, developers can pack extensions in a cross-platform format, in a ZIP archive with a metadata file placed in the root directory. Such extensions are also supported by Plesk for Windows.","Plesk for Linux is backwards-compatible with previously used extension (module) packages in RPM and Deb package formats. However, we highly recommend that you pack and distribute extensions in ZIP archives.","Extension Structure","71076.htm");
Page[6]=new Array("A typical ZIP archive with an extension has the following structure of files and directories:","example-extension.zip"," |"," +-meta.xml"," +-/htdocs/","   |","   +-index.php","   +-public/","   +-..."," +-/plib/","   |","   +-/hooks/","     |","     +-...","   +-/library/","     |","     +-EventListener.php","     +-...","   +-/scripts/","     |","     +-pre-install.php","     +-post-install.php","     +-pre-uninstall.php","     +-..."," +-/sbin/","   |","   +-..."," +-/var/","   |","   +-...","The description of the most important files and directories is as follows:","meta.xml","The XML-formatted description of an extension. During the extension installation, the file is extracted to ","PRODUCT_ROOT_D/admin/plib/modules/EXTENSION_ID/meta.xml,","where PRODUCT_ROOT_D is /usr/local/psa on Linux systems and %plesk_dir% on Windows systems.","/htdocs","All entry points of an extension, CSS, Javascript, and graphics files should be placed in this directory. During installation, the contents of this directory are extracted directly into /PRODUCT_ROOT_DIR/admin/htdocs/modules/EXTENSION_ID/.","/htdocs/public","Includes scripts that do not require authorization (bypassing controllers).","/plib","This directory should contain PHP classes that are responsible for the logic of an extension. During installation, the contents of this directory are extracted directly into PRODUCT_ROOT_D/admin/plib/modules/MODULE_ID/.","/plib/hooks","This directory should contain Plesk's hooks.","/plib/scripts","This directory should contain scripts that the system runs instantly before the extension installation, after the installation, or after the removal.","The following scripts are available:","pre-install.php - runs before extension files are copied. This script makes sure that the system meets the extension&#8217;s requirements. Extension files are not available at this stage.","post-install.php - runs after extension files are copied.&nbsp;This script prepares the system for the installation of the extension. Using this script, you can create databases or prepare the necessary directory structure.","pre-uninstall.php - runs before the removal of an extension. This script helps remove files used by the extension - databases, templates, user content.","If a script exits with a non-zero status, the current action is interrupted with an error. The script output will be displayed to the Plesk administrator as an error message.","/sbin/","This directory should contain scripts that require elevated privileges during execution.","/var","The directory for storing data used by the extension, for example, SQLite databases.","During the extension installation, the contents of this directory are extracted to PRODUCT_ROOT_D/var/modules/EXTENSION_ID/. This directory is not removed when upgrading an extension.","&nbsp;&nbsp;","File Structure","71076.htm#o71078");
Page[7]=new Array("A file that describes an extension, meta.xml, can look as follows:","&lt;?xml version=&quot;1.0&quot;?&gt;","&lt;module&gt;","  &lt;id&gt;test-extension&lt;/id&gt;","  &lt;name&gt;Test extension&lt;/name&gt;","  &lt;description&gt;Add description here...&lt;/description&gt;","  &lt;version&gt;1.0&lt;/version&gt;","  &lt;release&gt;1&lt;/release&gt;","  &lt;vendor&gt;Odin&lt;/vendor&gt;","  &lt;url&gt;http://your-company-web-site&lt;/url&gt;","  &lt;plesk_min_version&gt;12.5.0&lt;/plesk_min_version&gt;","&lt;/module&gt;","The description of the available elements within the module node is as follows:","id","The identifier of an extension. It is used as a part of the URL of the extension root. For example, if an extension ID is sample-extension, the extension is available at http://&lt;plesk-host-name&gt;:&lt;port&gt;/modules/sample-extension.","name","The name the administrators will see in the extensions list in Plesk (Server Management &gt; Extensions) after installing the extension.","(Optional) description ","The extension description the administrators will see in the extensions list in Plesk (Server Management &gt; Extensions) after installing the extension.","version","The extension version. Can be an arbitrary string, though we recommend using the following format: X.Y (where X and Y are numbers), e.g. 1.0. Administrators can see it in the extensions list.","release","The module package version. It corresponds to the package changes that do not affect the code of the extension, but change something in the package itself (such as the post-install script). Can be an arbitrary string, though we recommend using the following format: X (where X is a number), e.g. 1. Administrators can see it in the extensions list. ","(Optional) vendor","The vendor name.","(Optional) url","The extension's vendor site.","(Optional) plesk_min_version","The minimal version of Plesk which supports the extension.","(Optional) plesk_max_version","The maximum version of Plesk which supports the extension.","(Optional) help_url","The link to the extension documentation. Administrators can see it in the extensions list.","(Optional) os","Operating systems supported by the extension. Possible values: unix and win.","(Optional) encoder","Use this element if your extension is encoded by ionCube. Possible values: ioncube.","meta.xml","71076.htm#o71079");
Page[8]=new Array("When administrators upload a new version of an extension to Plesk, the possible conflicts between the existing and new files are resolved in the following way.","If a file already exists, it is overwritten.","If a directory already exists, files inside it are overwritten.","Files that were present in the previous version of an extension, but are missing in the newer version, are removed.","If one of these conflict resolution rules is not satisfied (for example, an existing file is blocked and cannot be overwritten), the upgrade procedure fails.","Conflict Resolution on Upgrade","71076.htm#o71080");
Page[9]=new Array("The following files are removed when an extension is removed:","PRODUCT_ROOT_D/admin/htdocs/modules/EXTENSION_ID/","PRODUCT_ROOT_D/admin/plib/modules/EXTENSION_ID/","PRODUCT_ROOT_D/var/modules/EXTENSION_ID/","Here PRODUCT_ROOT_D is /usr/local/psa on Linux systems and %plesk_dir% on Windows systems.","If an extension file cannot be removed, the removal procedure fails.","All files that are used by an extension should be removed by the pre-uninstall script.","Removal Procedure","71076.htm#o71082");
Page[10]=new Array("You can create the file structure necessary for an extension in one step, using the following command-line call:","plesk bin extension --create &lt;EXTENSION_NAME&gt;","Read more about the utility in the following documents:","(Linux) http://docs.plesk.com/current/cli-linux/71031.htm","(Windows) http://docs.plesk.com/current/cli-win/71033.htm","With this utility, you can create a ready-for-distribution extension (by creating a ZIP archive of the extension file structure). The following call prepares the archive in the current directory:","plesk bin extension -p my-project","If you need to create an archive in a different directory, supply the utility call with the -destination /path/to/directory/ option.","Creating and Packaging Extensions","71076.htm#o71083");
Page[11]=new Array("The system allows to call your classes from almost all places of your code without preliminary requiring them. For this, you should properly name the classes and put the file which contains the class into a particular directory. This simplification is not necessary in most cases, it just makes your code more compact, but sometimes you are required to adhere to the naming conventions. For example, if you wish to add a dashboard widget, you are required follow the conventions because the system needs to automatically discover and load this class.","The naming conventions are as follows:","The class name must start with the Modules_ExtensionName prefix. Here ExtensionName is the ID of your extension processed using the following instruction: ","Remove the dashes (-).","Change the first letter and letters that precede dashes to uppercase.","Example: my-site is transformed to MySite.","The class name must include the path to the directory where the file containing the class resides. The slashes (/) in the path are substituted by underscores (_). The path must be given relatively to the extension's /plib/library/ directory.","For example, if a class is in /plib/library/website/Promo.php and the extension ID is my-site, the class name must be:","Modules_MySite_Website_Promo.","Zend uses a similar approach for auto-loading classes. Read more about it in http://framework.zend.com/manual/1.11/en/learning.autoloading.design.html .","Limitations","The auto-loading of classes does not work in the /htdocs/public/ directory. If you need this feature, start the auto-loading manually by adding the following code to the beginning of a file:","require_once('sdk.php');","Class Naming Conventions","71076.htm#o71103");
Page[12]=new Array("To manage extensions from the command line, you can use a new utility called extensions. It is located in the directory %plesk-root%/bin. The utility provides the following functions: Installing new extensions, removing existing extensions, packing the source files of an extension into a ZIP archive ready for distribution, generating an extension template.","Usage","extension command [options]","Commands","Command","Parameter","Description"," --create or -c","&lt;name&gt;","Creates an extension template. Based on the template, you can develop a new extension.","Is used with the -no-ui and -no-scripts options.","--register or -r","&lt;name&gt;","Registers a specified extension.","--install or -i","&lt;file&gt;","Installs an extension from a .zip file.","--uninstall or -u","&lt;name&gt;","Removes a specified extension from Plesk.","--pack or -p ","&lt;name&gt;","Exports a specified extension to a .zip file for further distribution.","Is used with the -destination option.","--list or -l","Displays a list of installed extensions.","--help or -h","Displays a help page.","Options","Option","Parameter","Description","-destination ","&lt;path&gt;","A path to the directory where the exported extension should be located.","-no-ui","Do not add resource files defined by an extension template to a created extension. The new extension will contain a meta file and installation scripts only.","-no-scripts","Do not add installation scripts defined by an extension template to a created extension. The new extension will contain a meta file and resource files only.","Installing an Extension","Installation of an extension involves the following:","Extracting data from the archive.","Execution of the pre-install script.","Copying the parts of the extension to the specified directories.","Registration of the extension in the database.","Execution of the post-install script.","The following is an example of a command for installing an extension:","plesk bin extension -i my-extension.zip ","The extension was successfully installed.","You can also install an extension via the Plesk user interface.","Removing an Extension","Removal of an extension involves the following:","Execution of the pre-uninstall script.","Removal of information from the database (from the list of registered extensions).","Removal of the extension's files.","The following is an example of a command for removing an installed extension (an extension ID should be specified as a parameter):","plesk bin extension -u my-extension","The extension was successfully uninstalled.","You can also remove an extension via the Plesk user interface.","Creating a Template for a New Extension","To start developing a new extension, it is very handy to generate an extension template and start building around it.","The following is an example of a command for generating an extension template (an extension ID should be specified as a parameter):","plesk bin extension -c test-module","The extension was successfully created.","The path to extension entry points: /usr/local/psa/admin/htdocs/modules/test-module/","The path to PHP classes: /usr/local/psa/admin/plib/modules/test-module/","The path to installation scripts:  /usr/local/psa/admin/plib/modules/test-module/scripts/","The path to the directory with run-time data: /usr/local/psa/var/modules/test-module/","Parts of the extension will be placed in the following directories (relative to the %plesk-root% directory):","admin/htdocs/modules/test-module/ - extension entry points, graphics, CSS styles, JavaScript files.","admin/plib/modules/test-module/ - PHP classes that implement the extension's logic.","var/modules/test-module/ - a directory for storing data that are changed during the run-time, for example, SQLite database, cached data.","If development of the extension does not involve the use of an MVC pattern, you can avoid the creation of additional files by using the -no-ui option.","plesk bin extension -c test-module -no-ui","The extension was successfully created.","The path to installation scripts:  /usr/local/psa/admin/plib/modules/test-module/scripts/","The path to the directory with run-time data: /usr/local/psa/var/modules/test-module/","If development of batch scripts is not required, you can avoid the creation of additional files by using the -no-scripts option:","plesk bin extension -c test-module -no-scripts","The extension was successfully created.","The path to module entry points: /usr/local/psa/admin/htdocs/modules/test-module/","The path to PHP classes: /usr/local/psa/admin/plib/modules/test-module/","The path to the directory with run-time data: /usr/local/psa/var/modules/test-module/","Registering an Extension with Plesk","After an extension template is created, it is not considered as installed in Plesk and is not shown in the list of extensions. Registration involves the following:","Execution of the pre-install script.","Registration of the extension in the database.","Execution of the post-install script.","The following is an example of a command for registering an extension (an extension ID should be specified as a parameter):","plesk bin extension -r test-module","The extension was successfully registered.","You can perform registration a number of times, so consider this when implementing your pre-install and post-install scripts.","Preparing a Distribution Package","For your convenience, there is an option to generate a ZIP archive based on an installed extension. To do this, issue the following command:","plesk bin extension -p test-module","The extension was successfully exported to /root/test-module.zip","By default, a ZIP archive is created in the current directory. To create an archive in a specified directory, use the -destination option:","plesk bin extension -p test-module -destination /tmp/","The extension was successfully exported to /tmp/test-module.zip","Viewing a List of Installed Extensions","The utility can show a list of installed extensions with extension names and IDs. This command can be useful, for example, for retrieving the exact ID of an extension for further removal. An example of the command:","plesk bin extension -l","test-module - Extension example","Extensions Management Utility","73617.htm");
Page[13]=new Array("Plesk XML API and Command-Line Interface enable you to retrieve information about Plesk objects and edit these objects. However, if you need to retrieve properties of Plesk users and domains, you can easily do this by means of the pm_Client and  pm_Domain classes. We recommend that you use these classes for retrieving information about session objects as described below.","pm_Client","The pm_Client class represents a Plesk user account. This class supports retrieving information about a user either by their ID or by their username. It also lets you identify a user's account type: administrator, reseller, or customer. Finally, this class contains the getProperty method that lets you retrieve any user information from the table clients in the Plesk database psa. Examples of pm_Client usage are provided below.","1. Retrieving user information by their ID and identifying their username and account type:","    $client = pm_Client::getByClientId($id);","    echo &quot;Hello, {$client-&gt;getProperty('login')}&quot;;","    if ($client-&gt;isAdmin()) {","    	echo &quot;You are admin&quot;;","    } elseif ($client-&gt;isReseller()) {","    	echo &quot;You are reseller&quot;;","    } elseif ($client-&gt;isClient()) {","    	echo &quot;You are customer&quot;;","    }","2. Retrieving user ID by their username:","    $client = pm_Client::getByLogin($login);","    echo &quot;Your ID is {$client-&gt;getId()}&quot;;","pm_Domain","The pm_Domain  class represents a domain hosted in Plesk. This class supports retrieving information about a domain by its ID. Additionally, this class contains the getProperty method that lets you retrieve any domain information from the table domains in the Plesk database psa.","An example of pm_Domain usage is provided below.","    $domain = new pm_Domain($domainId);","    echo &quot;Domain name: {$domain-&gt;getName()}&quot;;","    echo &quot;Created at {$domain-&gt;getProperty('cr_date')}&quot;;","Session Control","If your extension needs to retrieve information from the user that is currently logged in to Plesk, use the pm_Session class.","Usage Examples","For restricting user access to the extension, retrieve the pm_Client object. The following code restricts access for all users except administrators:","    if (!pm_Session::getClient()-&gt;isAdmin()) {","    	throw new pm_Exception('Permission denied');","    }","If an administrator or a reseller is logged in the Control Panel as one of their customers, you can retrieve the customer's identifier the following way:","    if (pm_Session::isImpersonated()) {","    	$clientId = pm_Session::getImpersonatedClientId();","    	var_dump($clientId);","    }","Additionally, if the session is open in the Control Panel, you can retrieve information about the domain that is currently being operated on:","    $domain = pm_Session::getCurrentDomain();","    var_dump($domain-&gt;getName());","$domain in this example is an instance of the pm_Domain class.","If Plesk is unable to retrieve the domain, a pm_Exception will be thrown.","Retrieving User and Domain Data","73247.htm");
Page[14]=new Array("Extensions can obtain complete information and control over Plesk entities (customer accounts, service plans, and so on) via the XML API interface. This interface assumes exchanging operation requests wrapped into XML-structured packets. Plesk receives such an XML-structured operation request, processes it, and responds with a PHP class which fields mimic the XML tree structure. The structure of the XML packets is defined by the XML API protocol.","Every Plesk server supports a number of versions of XML API (for backward compatibility). It is possible send packets of a particular XML API version by explicitly providing the protocol version. If you do not specify the version, the most recent supported XML API version will be used.","Usage Examples","To perform an operation via XML API, run the call method of the pm_ApiRpc class.","$request = &lt;&lt;&lt;APICALL","&lt;webspace&gt;","  &lt;get&gt;","    &lt;filter&gt;","      &lt;id&gt;170&lt;/id&gt;","    &lt;/filter&gt;","    &lt;dataset&gt;","      &lt;gen_info/&gt;","    &lt;/dataset&gt;","  &lt;/get&gt;","&lt;/webspace&gt;","APICALL;","   ","$response = pm_ApiRpc::getService('1.6.3.3')-&gt;call($request);","echo 'Domain name: ' . $response-&gt;webspace-&gt;get-&gt;result-&gt;data-&gt;gen_info-&gt;name;","&nbsp;","Here is an example of an XML API call with an unspecified protocol version.","$request = '&lt;server&gt;&lt;get&gt;&lt;stat/&gt;&lt;/get&gt;&lt;/server&gt;';","$stats = pm_ApiRpc::getService()-&gt;call($request)-&gt;server-&gt;get-&gt;result-&gt;stat-&gt;objects;","&nbsp;","Often, when connected as a user without administrator's privileges, you need to perform actions that require administrator's rights. In this case, use the $login argument of the call method. ","For example, let's look at an extension that turns on PHP settings for a subscription. The extension sends the following request:","$request = &lt;&lt;&lt;APICALL","&lt;webspace&gt;","&nbsp; &lt;set&gt;","&nbsp;&nbsp;&nbsp; &lt;filter&gt;","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &lt;id&gt;2&lt;/id&gt;","&nbsp;&nbsp;&nbsp; &lt;/filter&gt;","&nbsp;&nbsp;&nbsp; &lt;values&gt;","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &lt;php-settings&gt;","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &lt;setting&gt;","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &lt;name&gt;extension&lt;/name&gt;","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &lt;value&gt;msql.so&lt;/value&gt;","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &lt;/setting&gt;","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &lt;/php-settings&gt;","&nbsp;&nbsp;&nbsp; &lt;/values&gt;","&nbsp; &lt;/set&gt;","&lt;/webspace&gt;","APICALL;","To perform this request, you need administrator's rights:","$response = pm_ApiRpc::getService()-&gt;call($request, 'admin');","&nbsp;","Error Handling","If you run an XML API call with data which is not a valid XML tree, a PHP warning will be generated.","If an XML packet is not a valid operation call, the system will throw the PleskAPIParseException exception.","Additional Information","For more information about XML API, refer to the XML API reference at http://docs.plesk.com/current/api-rpc/.","XML API","71086.htm");
Page[15]=new Array("Some extensions may use the command-line utilities that Plesk provides to administrators as an alternative to performing operations from the GUI. The Command-Line Interface (CLI) has the same functions as XML API, but an operation output is provided as a plain text rather than an XML tree. Learn more about the command-line utilities in the following documents:","(Linux) http://docs.plesk.com/current/cli-linux/","(Windows) http://docs.plesk.com/current/cli-win/","Usage Examples","A command-line call is performed by pm_ApiCli::call, the first argument is the utility name, and the second argument is the array of options and their values.","Note: The pm_ApiCli::call can only be called from command-line scripts, and not via operations in the Plesk GUI.","The following example retrieves information about the current Plesk license key:","$result = pm_ApiCli::call('keyinfo', array('-l'));","var_dump($result);","The output should be similar to the following:","array(3) {","    [&quot;code&quot;] =&gt;","        int(0)","    [&quot;stdout&quot;] =&gt;","        string(447) &quot;plesk_key_id: 0","        license_update_date: 20350101","        lim_date: 20120501","        lim_cl: -1","        ...","        &quot;","    [&quot;stderr&quot;] =&gt;","        string(0) &quot;&quot;","}","In more complex situations, divide a call into arguments and add each argument as an array item. For example:","customer --create johnusername -name &quot;John Doe&quot; -passwd sample -country US -notify false","should be transformed to:","pm_ApiCli::call('customer', array('--create', 'johnusername', '-name', 'John Doe', '-passwd', 'sample', '-country', 'US', '-notify', 'false'));","If you need to retrieve only a certain output parameter, for example, a result code, call pm_ApiCli::call with the third parameter which defines the parameter to output, for example:","$result = pm_ApiCli::call('license', array('-c'), pm_ApiCli::RESULT_CODE);","The $result variable will be assigned the result code.","Privileged Utilities","The directory /&lt;product-root&gt;/admin/bin/ contains utilities that are run with elevated privileges. In addition to this, an extension can bring some utilities that should be run with elevated privileges. Such utilities are placed in the directory /&lt;product-root&gt;/admin/bin/modules/$MODULE_NAME.","Note: Privileged utilities are only available in Plesk for Linux.","You can run such utilities by using the method callSbin:","$result = pm_ApiCli::callSbin('my-utility');","var_dump($result);","By default, the utility called my-utility will be searched for in the directory /&lt;product-root&gt;/admin/bin/modules/$MODULE_NAME. If the utility is not found, it will then be searched for in the directory /usr/local/psa/admin/bin/.","Command-Line Interface","71088.htm");
Page[16]=new Array("Starting with Plesk 12.5, it is possible to implement group operations. You can find a usage example here: https://github.com/plesk/ext-example/commit/85c9ac5c62ff8dc82765e9ce16f56ee5d238cc30 (see line 204 onwards).","List Group Operations Support","75342.htm");
Page[17]=new Array("Quite often an extension needs a storage to keep its data - for example, user settings or secret keys. To access the Plesk key-value storage, use the pm_Settings interface. Keys and values are stored in the context of an extension.  ","If you need to assign a variable, use pm_Settings::set. For example:","pm_Settings::set('authToken', $authToken);","Now you can retrieve the value of this variable by pm_Settings::get. For example:","pm_Settings::get('authToken', $authToken);","To obtain access to them in some places of code, initialize the context first:","pm_Context::init('extension-id');","It is mandatory to initialize the context in the following places in code:","Scheduled tasks.","Post- and Pre- installation scripts.","Event handlers.","Key-value Cleaning","Starting with Plesk 12.5, it is possible to clear the extension settings using the pm_Settings::clean method. You can use it to add a &quot;Reset to default&quot; button to the UI of your extension.","The Key-Value Storage","71092.htm");
Page[18]=new Array("The event handlers interface lets you subscribe to a particular Plesk event and trigger a particular action depending on the event information. For example, if you need to create a DNS zone each time a new domain is created, use event handlers. ","For triggering simple actions, such as logging information about Plesk events, we recommend that you use the event tracking mechanism available in the Plesk UI. To learn how to use this mechanism, refer to the Administrator's Guide, section Event Tracking.","For complicated actions, Plesk provides another, more flexible, mechanism of event tracking. This mechanism allows running PHP scripts upon Plesk events. In this section, we will explain in detail how to use it.","How to Create a Handler","Event handlers examine the Plesk action log and invoke the handleEvent method each time an action is added to the log. Thus, event handler cannot prevent the action. If an attempt to perform the action fails, Plesk does not issue notifications through this mechanism.","Event handlers for the same event can be triggered in an arbitrary order.","To add an event handler, create a .php file in the following directory:","On Linux: /usr/local/psa/admin/plib/registry/EventListener","On Windows:  &lt;plesk_dir&gt;\\admin\\plib\\registry\\EventListener","Where &lt;plesk_dir&gt; stands for the full path to the directory where Plesk is installed. ","This file must contain a class which implements the handleEvent method of the EventListener interface. The code must create an instance of this class and return it. For example:","&lt;?php","class TestEventListener implements EventListener","{","	public function handleEvent($objectType, $objectId, $action, $oldValues, $newValues)","	{","		// TODO: add implementation here...","	}","}","return new TestEventListener();","?&gt;","Read more about the handleEvent parameters in handleEvent Method. The complete listings of available object types, actions, and value arrays are available in corresponding subsections of this section.","Adding Event Handlers to Extensions","If you have an extension and want it to trigger certain actions upon Plesk events, add an event handler to your extension. Assume that your extension's ID is my-extension.","To add an event handler to the extension:","Create a .php file with the content described above.","Change the class name to Modules_MyExtension_EventListener. For more information about assigning names to classes within your extension, refer to Class Naming Conventions. ","Change the file's name to EventListener.php.","Place the file to /plib/library/ inside the extension directory.","Debugging a Handler Code","To debug the handleEvent method, you can use the following code:","&lt;?php","class TestEventListener implements EventListener","{ ","    public function handleEvent($objectType, $objectId, $action, $oldValues, $newValues)","    {","    		error_log('inside TestEventListener::handleEvent');","    }","}","return new TestEventListener();","?&gt;","After an event occurs, this handler will be invoked.","The output will be available in the following files:","On Linux: /var/log/sw-cp-server/error_log","On Windows: &lt;plesk_dir&gt;\\admin\\logs\\php_error.log","Event Handlers","71093.htm");
Page[19]=new Array("This method is called by Plesk once per business logic event. It contains event parameters that can be used by extensions.","Input arguments","$objectType","Data type: string. ","Specifies the type of the affected object.","For details on allowed values for this argument, refer to the Object Types and Actions section.","&nbsp;","$objectId","Data type: integer.","Specifies ID of the affected object. 0 if not applicable (singleton object like 'client_limit_size').","&nbsp;","$action","Data type: string. ","Specifies the action caused the event. Each action has the following presentation: &lt;$objectId&gt;_&lt;postfix&gt;.","Allowed postfixes: create | update | delete | start | stop | restart | reached | added | removed | login | logout | change | install | reconfigure | upgrade | expired","&nbsp;","$oldValues","Data type: associative array.","Contains object parameters that are updated after the event happened. The array contains one entry per changed parameter. The entry key is the action log parameter name, and the entry value is the old value of the parameter.","Example:","array(","    'ip_address' =&gt; '192.0.2.12',","    'ip_mask' =&gt; '255.255.255.0',","    'interface' =&gt; 'eth0'","    'ip_type' =&gt; 'shared'",")","&nbsp;","$newValues","Data type: associative array.","Contains object parameters that are updated after the event happened (one entry per changed parameter). The set of keys in this array will be exactly the same as for $oldValues. The entry key is the action log parameter name, and the entry value is the new value of the parameter.","For details on what array items are available for a combination of an action and objects affected by the action, refer to the Old and New Values Combinations section. For details on the meaning of a specific key, refer to the Old and New Values Description section.","Notes:<br>1. Some parameters appear in both arrays for informational purposes even if unchanged. <br>2. All parameters values are stored as strings. For instance, the value of a boolean parameter is the true or false string.","Return values","None.","handleEvent Method","38926.htm");
Page[20]=new Array("The following table shows allowed types of objects and actions that affect objects of the specific type.","Important: Plesk 10 introduced significant changes to the Plesk business model. This affected not only the business logic, but the naming of key Plesk objects as well. For example, the domain object turned into subscription. For details, see the section Upgrade from Earlier Plesk Versions of the Plesk Administrator's Guide. ","However, due to backward compatibility reasons, the new naming was not applied to object types listed below. Please pay special attention when using object types for the actions you need.","Object type","Action","admin","Administrator information updated","client","Customer account created, updated or removed","client_ip_pool","Customer's IP pool changed","client_limit_size","Maximum amount of disk space reached for a client","client_limit_traffic","Maximum amount of traffic reached for a client","client_limits","Customer's limits updated","client_permissions","Customer's permissions updated","client_preferences","Customer's interface preferences updated","client_siteapp","Web application is added or removed by a customer","client_status","Customer's status updated. (Status shows if a client is suspended or not)","cp_user","User logged in to a Control Panel, or logged out from it","db","Database created or removed","db_server","Database server created, updated or removed","db_user","Database user created, updated or removed","domain","Subscription created, updated, or removed","domain_alias","Domain alias created, updated or removed","domain_alias_dns","DNS zone was updated for a domain alias","domain_dns","DNS zone was updated for a domain","domain_limit_size","Maximum amount of disk space reached for a subscription","domain_limit_traffic","Maximum amount of traffic reached for a subscription","domain_limits","Subscription limits updated","domain_owner","Subscription ownership is transferred to other customer account","domain_status","Subscription status updated","forwarding","Forwarding created, changed, or removed","ip_address","IP address created, changed, or removed","license ","License key updated","maillist","Mailing list created, updated, or removed","mailname","Mail account created, updated, or removed","phosting","Physical hosting created, updated, or removed","plesk_component","Plesk component upgraded (via Plesk Installer or manually)","service ","Service stopped, started, or restarted","session_preferences","Session preferences updated","site","Domain created, updated, or removed","siteapp","Web application is installed, upgraded, reconfigured, or uninstalled","siteapppkg","Web application package is installed, updated, or removed","subdomain","Subdomain created, updated, or removed","template_admin","Service plan created, updated, or removed by admin.","webuser","Web user created, updated, or removed","&nbsp;","Object Types and Actions","49260.htm");
Page[21]=new Array("The following table contains available the elements of $oldValues and $newValues arrays for a certain action. The descriptions on the keys are available in Old and New Values Description.","Object type","Action","Keys","admin","admin_update","login_name<br>contact_name<br>company_name<br>phone<br>fax<br>email<br>address<br>city<br>state_province<br>postal_zip_code<br>country ","template_admin","template_admin_create template_admin_update template_admin_delete","template_admin","service ","service_stop<br>service_start<br>service_restart","service ","ip_address ","ip_address_create","ip_address_update","ip_address<br>ip_mask<br>interface<br>ip_type ","ip_address_delete","ip_address","session_preferences ","session_preferences_update","session_idle_time ","client ","client_create<br>client_update<br>client_delete ","contact_name<br>login_name<br>company_name<br>phone<br>fax<br>email<br>address<br>city<br>state_province<br>postal_zip_code<br>country ","client_status ","client_status_update","contact_name<br>login_name<br>status ","client_limits ","client_limits_update ","login_name<br>maximum_domains<br>maximum_domain aliases<br>maximum_subdomains<br>maximum_disk_space<br>maximum_traffic<br>maximum_webusers<br>maximum_databases<br>maximum_mailboxes<br>maximum_mailbox_quota<br>maximum_mail_redirects<br>maximum_mail_groups<br>maximum_mail_autoresponders<br>maximum_mail_lists<br>maximum_tomcat_web_applications<br>expiration_date ","client_limit_traffic ","client_limit_traffic_reached","contact_name<br>maximum_traffic ","client_limit_size ","client_limit_size_reached","contact_name<br>maximum_disk_space ","client_permissions ","client_permissions_update","login_name<br>cp_access<br>domain_creation<br>physical_hosting_management<br>php_safe_mode_management<br>hard_disk_quota_assignment<br>subdomains_management<br>domain_aliases_management<br>limits_adjustment<br>dns_zone_management<br>log_rotation_management<br>scheduler_management**<br>crontab_management* anonymous_ftp_management<br>web_applications_management<br>web_statistics_management<br>system_access_management<br>non_chrooted_shell_management<br>mailing_lists_management<br>backup_restore_functions_use_local_repository<br>backup_restore_functions_use_ftp_repository<br>ability_to_use_remote_xml_interface<br>ability_to_use_dashboard_interface<br>ability_to_use_standard_interface<br>ability_to_manage_dashboard<br>ability_to_manage_spamfilter<br>ability_to_manage_virusfilter ","client_preferences ","client_preferences_update","contact_name<br>login_name<br>allow_multiple_sessions<br>interface_language<br>interface_skin<br>desktop_preset_id ","client_ip_pool ","client_ip_pool_update","login_name<br>ip_address<br>status ","client_siteapp ","client_siteapp_added<br>client_siteapp_removed ","login_name<br>package_name ","domain ","domain_create","domain_name","ip_addess","ip_v6_address","domain_update","domain_name","domain_delete ","domain_name","system_user","domain_status ","domain_status_update ","domain_name<br>status ","domain_dns ","domain_dns_update ","domain_name ","domain_owner ","domain_owner_change ","login_name<br>domain_name ","subdomain ","subdomain_create<br>subdomain_update<br>subdomain_delete ","domain_name<br>subdomain_name<br>system_user_type<br>system_user<br>ssi_support<br>php_support<br>cgi_support<br>mod_perl_support<br>mod_python_support<br>mod_fastcgi_support<br>miva_support<br>apache_asp_support<br>asp_net_support**<br>ssl_support<br>hard_disk_quota ","domain_alias ","domain_alias_create<br>domain_alias_update<br>domain_alias_delete ","domain_alias_name<br>status<br>dns<br>mail<br>web<br>tomcat<br>domain_id ","domain_alias_dns ","domain_alias_dns_update ","domain_alias_name ","domain_limits ","domain_limits_update ","domain_name<br>maximum_domain aliases<br>maximum_subdomains<br>maximum_disk_space<br>maximum_traffic<br>maximum_webusers<br>maximum_databases<br>maximum_mailboxes<br>maximum_mailbox_quota<br>maximum_mail_redirects<br>maximum_mail_groups<br>maximum_mail_autoresponders<br>maximum_mail_lists<br>maximum_tomcat_web_applications<br>expiration_date ","domain_limit_traffic ","domain_limit_traffic_reached ","domain_name<br>maximum_traffic ","domain_limit_size ","domain_limit_size_reached ","domain_name<br>maximum_disk_space ","cp_user ","cp_user_login<br>cp_user_logout ","contact_name ","mailname ","mailname_create<br>mailname_update<br>mailname_delete ","mailname<br>password<br>antivirus<br>domain_id<br>domain_name<br>mail_alias<br>mail_preferences ","maillist ","maillist_create<br>maillist_update<br>maillist_delete ","domain_name<br>mail_list_name<br>mail_list_enabled ","phosting ","phys_hosting_create<br>phys_hosting_update<br>phys_hosting_delete ","domain_name<br>ip_address<br>ip_type<br>system_user<br>system_shell<br>hard_disk_quota<br>system_user_password<br>fp_support<br>fp_ssl_support<br>fp_authorization<br>fp_admin_login<br>fp_admin_password<br>ssl_support<br>web_statistics<br>apache_error_documents<br>ssi_support<br>php_support<br>cgi_support<br>mod_perl_support<br>mod_python_support<br>mod_fastcgi_support<br>miva_support<br>apache_asp_support<br>asp_net_support**<br>ssl_support ","forwarding","forwarding_create<br>forwarding_update ","domain_name<br>forwarding_type<br>url<br>ip_address","forwarding_delete ","domain_name<br>forwarding_type ","webuser ","webuser_create<br>webuser_update ","domain_name<br>webuser_name<br>webuser_password<br>hard_disk_quota<br>ssi_support<br>php_support<br>cgi_support<br>mod_perl_support<br>mod_python_support<br>mod_fastcgi_support<br>apache_asp_support<br>asp_net_support**<br>ssl_support ","webuser_delete ","domain_name<br>webuser_name","site","site_create","domain_name","ip_addess","ip_v6_address","site_update","domain_name","site_delete","domain_name","system_user","siteapp","siteapp_install ","package_name","siteapp_reconfigure<br>siteapp_uninstall ","package_name<br>domain_type<br>directory<br>installation_prefix ","siteapp_upgrade ","domain_type<br>directory<br>installation_prefix<br>upgrade_to_version<br>upgrade_to_release<br>app_files_backup<br>app_databases_backup ","siteapppkg ","siteapppkg_install<br>siteapppkg_update<br>siteapppkg_uninstall ","package_name ","license ","license_update","license<br>license_type<br>license_name ","license_expired","license ","db_server ","database_server_create<br>database_server_update<br>database_server_delete ","database_server ","db ","database_create<br>database_delete ","database_server<br>database_name ","db_user ","database_user_create<br>database_user_delete ","database_server<br>database_id<br>database_user_name","database_user_update","database_server<br>database_id<br>database_user_name<br>database_user_password","plesk_component ","plesk_component_upgrade ","plesk_component_name ","<br>* - The key is available only in Plesk for Linux\\Unix","** - The key is available only in Plesk for Windows","Old and New Values Combinations","49269.htm");
Page[22]=new Array("The following table contains names and descriptions of $new_values and $old_values entries keys.","Key","Type","Description","ability_to_manage_spamfilter","boolean","Ability to manage spam filters","ability_to_manage_virusfilter ","boolean","Ability to manage spam filters","ability_to_use_remote_xml_interface","boolean","Ability to use XML API protocol","ability_to_use_standard_interface","boolean","Ability to use &quot;standard view&quot; control panel interface","address","string","Address (user data)","allow_multiple_sessions","boolean","Ability to have several simultaneous sessions in the control panel for Plesk user","anonymous_ftp_management","boolean","Ability to have an FTP directory where all web users could download and upload files without the need to enter login and password.","antivirus","string","Name of the antivirus used by a mail account","apache_asp_support","boolean","Ability to run ASP scripts","apache_error_documents","boolean","Ability to customize HTML pages with standard  error messages (404 error, 500 error, etc.).","app_databases_backup","app_files_backup","asp_net_support ","boolean","Ability to run ASP.NET applications on the server","backup_restore_functions_use_ftp_repository","boolean","Flag indicating that backups are stored in a FTP repository","backup_restore_functions_use_local_repository","boolean","Flag indicating that backups are stored in the local repository","cgi_support","boolean","Ability to run CGI scripts on the server","city","string","Form field City","company_name","string","Company name (user data)","contact_name","string","Contact name (user data)","country ","string","Country (user data)","cp_access","boolean","Ability to log in to Plesk control panel","crontab_management","boolean","Ability to schedule tasks on behalf of user &quot;root&quot; for Plesk users","database_id","integer","Database ID","database_name","string","Database name","database_server","string","Database server host name or IP address","database_user_name","string","Login of a database administrator","database_user_password","string","Password of a database administrator","directory","string","Directory where site application is located","dns","boolean","Flag, indicating that domain alias DNS zone is synchronized with the primary domain zone","dns_zone_management","boolean","Ability to manage DNS zone on for Plesk users","domain_alias_name","string","Domain alias name","domain_aliases_management","boolean","Ability to manage domain aliases","domain_creation","boolean","Ability to set up hosting accounts for new sites","domain_id","integer","Domain ID","domain_name","string","Domain name","domain_type","string","Flag indicating whether a site application will be installed on a domain or on a sub-domain. Allowed values: domain, sub-domain","email","string","Email address (user data)","expiration_date","string","Expiration date","fax","string","Fax number (user data)","forwarding_type","string","Forwarding type (Frame forwarding or Standard forwarding).","fp_admin_login","string","FTP server login","fp_admin_password","string","FTP server password","fp_authorization","boolean","Flag, indicating that authorization is required","fp_ssl_support","boolean","Ability to use SSL","fp_support","boolean","Ability to use FTP server","hard_disk_quota","integer","Amount of space on a hard drive available for Plesk user","hard_disk_quota_assignment","boolean","Ability to assign hard disk space quotas to Plesk users","installation_prefix","Directory (relative to document root of a vhost), to which the web application is installed","interface","string","Network interface","interface_language","string","Control panel locale name","interface_skin","string","Control panel skin name","ip_address","string","IP address","ipv6_address","string","IPv6 address","ip_mask","string","IP address mask","ip_type ","string","IP address type (shared or dedicated)","license","string","License text","license_name","string","License name","license_type","string","License type","limits_adjustment","boolean","Ability to adjust Plesk user limits","log_rotation_management","boolean","Ability to manage Rotation log","login_name","string","Login name","mail","boolean","Ability to redirect mail from a domain alias to the original domain","mail_alias","boolean","Ability to create mail aliases","mail_list_enabled","boolean","Flag indicating that mailing list is enabled","mail_list_name","string","Mailing list name","mail_preferences","mailing_lists_management","boolean","Ability to manage mailing lists","mailname","string","Mail account name","manage_ftp_password","boolean","Ability to manage FTP password","maximum_databases","integer","Maximum databases limit","maximum_disk_space","integer","Maximum databases limit","maximum_domain aliases","integer","Maximum domain aliases limit","maximum_domains","integer","Maximum domains limit","maximum_mail_autoresponders","integer","Maximum number of autoresponders","maximum_mail_groups","integer","Maximum mail groups limit","maximum_mail_lists","integer","Maximum number of mailing lists","maximum_mail_redirects","integer","Maximum mail redirects limit","maximum_mailbox_quota","integer","Maximum hard disk space allocated for a mailbox limit","maximum_mailboxes","integer","Maximum number of mailboxes limit","maximum_subdomains","integer","Maximum subdomains limit","maximum_tomcat_web_applications","integer","Maximum tomcat applications limit","maximum_traffic","integer","Maximum traffic limit","maximum_webusers","integer","Maximum web users limit","miva_support","boolean","Ability to run Miva applications","mod_fastcgi_support","boolean","Ability to support FastCGI protocol","mod_perl_support","boolean","Ability to support Perl scripts","mod_python_support","boolean","Ability to support python srcipts","non_chrooted_shell_management","boolean","Ability to use shell (without root-level access)","mod_perl_support","boolean","Ability to support Perl scripts","package_name","string","Site application name","password","string","Password","phone","string","Phone (user data)","php_safe_mode_management","boolean","Ability to make PHP operate in safe mode with functional restrictions","php_support","boolean","Ability to support PHP scripts","physical_hosting_management","boolean","Ability to manage physical hosting settings","plesk_component_name ","boolean","Name of Plesk component","postal_zip_code","string","ZIP code (user data)","retain_traffic_statistics","string","Defines how long the statistics are stored on the server","scheduler_management","boolean","Ability to schedule tasks in the system","service","string","Service name","session_idle_time ","string","Session idle time","ssi_support","boolean","Ability to support SSI","ssl_support","boolean","Ability to support SSL","state_province","string","State or province (user data)","status","string","Status of Plesk user (enabled or disabled)","subdomain_name","string","Subdomain name","subdomains_management","boolean","Ability to manage subdomains","system_access_management","boolean","Ability to manage system shell access","system_shell","boolean","Ability to access system shell on the server","system_user","Login of FTP user on a domain or a sub-domain with physical hosting, or web user","system_user_password","Password of FTP user on a domain or a sub-domain with physical hosting, or web user","system_user_type","Type of a sub-domain user. The user credentials can be inherited from domain user, or can be defined separately.","template_admin","integer","Service plan ID","tomcat","boolean","Ability to redirect Java applications from a domain alias to the Tomcat server on a primary domain","upgrade_to_release","string","Release number","upgrade_to_version","string","Version number","url","string","URL to which web users are forwarded","web","sting","Ability to redirect web content from a domain alias to the original domain","web_applications_management","boolean","Ability to manage web applications","web_statistics","string","Tool that analyzes statistics (Webalizer or AWStats)","web_statistics_management","boolean","Ability to manage web statistics","webuser_name","string","Web user name","webuser_password","string","Web user password","www_prefix","boolean","Ability to access the site by a URL like www.example.com","Old and New Values Description","49271.htm");
Page[23]=new Array("An extension can run some of its routines periodically, for example, every 10 minutes, every hour, or daily. This scheduler interface manages the crontab utility on Linux and the Task Scheduler application on Windows. The interface is presented by two classes - pm_Scheduler and pm_Scheduler_Task. The first class represents a task manager and the second class represents a task.","To successfully schedule a task, your code must meet the following requirements:","Put a scheduled task under /plib/scripts/ relatively to the extension's root directory.","Initialize the extension context (pm_Context::init) before scheduling a task.","Schedule the task using pm_Scheduler and pm_Scheduler_Task.","Usage Examples"," A sample code that adds a periodic task to the scheduler can look as follows:","$task = new pm_Scheduler_Task();","$task-&gt;setSchedule(array(","    'minute' =&gt; '0,4,9,14,19,24,29,34,39,44,49,54,59',","    'hour' =&gt; '*',","    'dom' =&gt; '*',","    'month' =&gt; '*',","    'dow' =&gt; '*'","    ));","$task-&gt;setCmd('five-minutes-task.php');","pm_Context::init('extension-id');","pm_Scheduler::getInstance()-&gt;putTask($task);  ","var_dump($task-&gt;getId()); // Save task id in order to remove it if necessary","See an example of using scheduled tasks in Exercise 2.","Designing a Run Schedule","When designing a run schedule, you should pay attention to the following operating-system differences:","On Linux, the schedule may be specified in the cron format. Learn more about the format at: http://www.nncron.ru/help/EN/working/cron-format.htm.","On Windows, the schedule may be set by using commas (,) and asterisks (*).","We recommend that you use the following cross-platform constants when defining a period between two task runs:","    pm_Scheduler::$EVERY_MIN","    pm_Scheduler::$EVERY_5_MIN","    pm_Scheduler::$EVERY_10_MIN","    pm_Scheduler::$EVERY_HOUR","    pm_Scheduler::$EVERY_DAY","    pm_Scheduler::$EVERY_WEEK","    pm_Scheduler::$EVERY_MONTH","On Windows, a task is limited to 48 different start conditions (triggers). Learn more about triggers and the limitation at:<br>http://msdn.microsoft.com/en-us/library/windows/desktop/aa383619%28v=vs.85%29.aspx","Listing Tasks","If you need to loop through scheduled tasks, do it in the following way:","$tasks = pm_Scheduler::getInstance()-&gt;listTasks();","foreach ($tasks as $task) {","    var_dump($task-&gt;getId());","    var_dump($task-&gt;getSchedule());","    var_dump($task-&gt;getCmd());","}","Removing Scheduled Tasks","We highly recommend that you save IDs of your scheduled tasks to the key-value storage and then remove the tasks during the removal of your extension. The following code removes a task:","$task = pm_Scheduler::getInstance()-&gt;getTaskById('64daef15d48e0fe038bb20a77a171150');","pm_Scheduler::getInstance()-&gt;removeTask($task);","Passing Arguments to Tasks","If you need to pass certain arguments to a task, use the setArguments method. The following code creates a task with arguments:","$task = new pm_Scheduler_Task();","$task-&gt;setSchedule(pm_Scheduler::$EVERY_DAY);","$task-&gt;setCmd('send-daily-report.php');","$task-&gt;setArguments(array('john', 'robert', 'ivan'));","pm_Scheduler::getInstance()-&gt;putTask($task);","To retrieve a task's arguments, use the getArguments method, for example, in the following way:","var_dump($task-&gt;getArguments());","&nbsp;","Note that a task ID is assigned by the putTask method.&nbsp;","Scheduled Tasks","71094.htm");
Page[24]=new Array("Starting from Plesk 11.5, you can create extensions that add functionality to Plesk File Manager and manage domain files by themselves.","File Manager's Context Menu","To add an item to the context menu of the File Manager:","Create the file /plib/library/FileManager/Action.php in your extension directory.","Create the class Modules_MyModule_FileManager_Action that extends the pm_FileManager_Action class in this file. MyModule here is your extension's ID.","An example of such class in provided below:","    class Modules_CodeEditor_FileManager_Action extends pm_FileManager_Action","    {","    	/**","    	* Retrieve title for action","    	*/","    	public function getTitle()","    	{","    		pm_Context::init('code-editor');","     ","    		return $this-&gt;lmsg('actionTitle');","    	}","     ","    	/**","    	* Retrieve name for action","    	* by default name is camelCase module ID","    	*/","    	public function getName()","    	{","    		return parent::getName();","    	}","     ","		    /**","    	* Retrieve URL for action","    	*/","    	public function getHref()","    	{","    		pm_Context::init('code-editor');","     ","    		$params = array(","    		'currentDir=' . urlencode($this-&gt;_item['currentDir']),","    		'file=' . urlencode($this-&gt;_item['name']),","    		);","    		return pm_Context::getBaseUrl() . '?' . implode('&amp;', $params);","    	}","     ","    	/**","    	* Checks if action is available for a file","    	*/","    	public function isActive()","    	{","    		if ($this-&gt;_item['isDirectory']) {","    			return false;","    		}","     ","    		return true;","    	}","     ","    	/**","    	* Checks if action is default for a file","    	*/","    	public function isDefault()","    	{","    		return false;","    	}","    }","The variable $this-&gt;_item contains an array with the information about the file or a directory on which the menu is shown:","array (","    'name' =&gt; 'hello.txt',","    'modificationTimestamp' =&gt; '1380276799',","    'modificationDate' =&gt; 'Sep 27, 2013 05:13 PM',","    'size' =&gt; '8192',","    'formatedSize' =&gt; '8.0 KB',","    'user' =&gt; 'user_ifvbjsgcdk',","    'group' =&gt; 'psacln',","    'filePerms' =&gt; 'rw- r-- r-- ',","    'isDirectory' =&gt; false,","    'icon' =&gt; '/theme/icons/16/plesk/file-txt.png',","    'isReadonly' =&gt; false,","    'currentDir' =&gt; '/httpdocs',",")","The result of adding such an extension is shown below:","Managing Webspace Files and Directories","To manage files and directories within a domain, use the pm_FileManager class. This class lets you create and remove files and directories, check for the existence of files and directories, read and write data to files, and also change file and directory permissions (only on Linux).","Important: For security considerations, we strongly recommend that you do not use system calls such as fopen or file_get_contents in the code of your extension. When you use such calls, the extension works with files on behalf of the psaadm user. In turn, if you use the pm_FileManager class, the manipulations are performed on behalf of the domain owner's system user.","Below is an example of working with files by means of the pm_FileManager class.","    $fileManager = new pm_FileManager($domainId);","    $filePath = $fileManager-&gt;getFilePath(&quot;$currentDir/$file&quot;);","    if ($fileManager-&gt;fileExists($filePath)) {","    	$fileData = $fileManager-&gt;fileGetContents($filePath);","    	// Some manipulation with file data...","    	$fileData = str_replace('foo', 'bar', $fileData);","  	   ","    	$fileManager-&gt;filePutContents($filePath, $fileData);","    }","The $filePath path here is an absolute path. It is formed from the relative path within the domain directory $currentDir by the call of the getFilePath method.","Managing Server Files and Directories","To manage files and directories anywhere on the server, use the pm_ServerFileManager class. This class enables you to perform the same operations as the pm_FileManager class.","Below is an example of working with files by means of the pm_ServerFileManager class.","	$fileManager = new pm_ServerFileManager();","	$configPath = PRODUCT_ROOT . '/admin/conf/panel.ini';","	if ($fileManager-&gt;fileExists($configPath)) {","		$fileData = $fileManager-&gt;fileGetContents($filePath);","		// Some manipulation with file data...","		$fileData = str_replace('foo', 'bar', $fileData);","		$fileManager-&gt;filePutContents($filePath, $fileData);","	}","File Manager","73250.htm");
Page[25]=new Array("One of the tasks the extension developers face is retrieving the data about the Plesk license keys installed on the server. To make it easy for an extension to obtain the Plesk license key information, the pm_License class was introduced in Plesk 12.5.","The pm_License class enables the retrieval of the main and add-on Plesk license keys, as well as retrieval of the list of all add-on keys with the ability to filter by the product name. Some usage examples are provided below:","Creating a new main license key object:","$license = new pm_License();","Creating a new add-on license key object:","$keyNumber = 'APS.02960584.0008';","$license = new pm_License($keyNumber);","Retrieving the values of all license key properties:","$license-&gt;getProperties();","Retrieving the value of a license key property with a specific name:","$license-&gt;getProperty('security-core');","Retrieving the list of all add-on keys:","pm_License::getAdditionalKeysList();","Retrieving the list of all add-on keys with a specific product name:","$productName = 'security-core-with-atomicorp-modsecurity-rules';","pm_License::getAdditionalKeysList($productName);","Retrieving Plesk License Information","75339.htm");
Page[26]=new Array("Starting with Plesk 12.5, it is possible to specify the default column for sorting via the options on creation of a pm_View_List_Simple class object. You can find a usage example here:","https://github.com/plesk/ext-example/commit/85c9ac5c62ff8dc82765e9ce16f56ee5d238cc30 (see lines 185-189).","Default Column for Sorting","75335.htm");
Page[27]=new Array("url","We recommend using the url helper for creating links.","Controller:","    $this-&gt;view-&gt;uplevelLink = $this-&gt;_helper-&gt;url('action', 'controller');","View:","    &lt;a href=&quot;&lt;?php echo $this-&gt;url(array(","        'controller' =&gt; 'index',","        'action' =&gt; 'index',","    )); ?&gt;&quot;&gt;Link&lt;/a&gt;","lmsg","Output of localized messages.","Controller:","    $this-&gt;view-&gt;message = $this-&gt;lmsg('helloMessage');","View:","    &lt;b&gt;&lt;?php echo $this-&gt;lmsg('helloMessage'); ?&gt;&lt;/b&gt;","renderList","Rendering of lists.","Controller:","    private function _getNumbersList()","    {","        $data = array();","        $iconPath = pm_Context::getBaseUrl() . 'images/icon_16.gif';","        for ($index = 1; $index &lt; 150; $index++) {","            $data[] = array(","                'column-1' =&gt; '&lt;a href=&quot;#&quot;&gt;link #' . $index . '&lt;/a&gt;',","                'column-2' =&gt; '&lt;img src=&quot;' . $iconPath . '&quot; /&gt; image #' . $index,","            );","    }","    $list = new pm_View_List_Simple($this-&gt;view, $this-&gt;_request);","    $list-&gt;setData($data);","    $list-&gt;setColumns(array(","        'column-1' =&gt; array(","            'title' =&gt; 'Link',","            'noEscape' =&gt; true,","            'searchable' =&gt; true,","        ),","        'column-2' =&gt; array(","            'title' =&gt; 'Description',","            'noEscape' =&gt; true,","            'sortable' =&gt; false,","        ),","    ));","    $list-&gt;setTools(array(","        array(","            'title' =&gt; 'Example',","            'description' =&gt; 'Example module with UI samples',","            'class' =&gt; 'sb-app-info',","            'link' =&gt; pm_Context::getBaseUrl(),","        ),","        array(","            'title' =&gt; 'Modules',","            'description' =&gt; 'Modules installed in the Panel',","            'class' =&gt; 'sb-suspend',","            'link' =&gt; pm_Context::getModulesListUrl(),","        ),","    );","    // Take into account listDataAction corresponds to the URL /list-data/","    $list-&gt;setDataUrl(array('action' =&gt; 'list-data'));","    return $list;","    }","     ","    public function listAction()","    {","        $list = $this-&gt;_getNumbersList();","        // List object for pm_View_Helper_RenderList","        $this-&gt;view-&gt;list = $list;","    }","     ","    public function listDataAction()","    {","        $list = $this-&gt;_getNumbersList();","        // Json data from pm_View_List_Simple","        $this-&gt;_helper-&gt;json($list-&gt;fetchData());","    }","View:","    &lt;?php echo $this-&gt;renderList($this-&gt;list); ?&gt;","renderTools","Rendering of buttons.","Controller:","    $this-&gt;view-&gt;tools = array(","        array(","            'icon' =&gt; pm_Context::getBaseUrl() . &quot;img/site-aps_32.gif&quot;,","            'title' =&gt; 'Example',","            'description' =&gt; 'Example extension with UI samples',","            'link' =&gt; pm_Context::getBaseUrl(),","        ),","        array(","            'icon' =&gt; pm_Context::getBaseUrl() . &quot;img/modules_32.gif&quot;,","            'title' =&gt; 'Extensions',","            'description' =&gt; 'Extensions installed in the Panel',","            'link' =&gt; pm_Context::getModulesListUrl(),","        ),","    );","View:","    &lt;?php echo $this-&gt;renderTools($this-&gt;tools); ?&gt;","renderSmallTools","Rendering of small buttons.","Controller:","    $this-&gt;view-&gt;smallTools = array(","        array(","            'title' =&gt; 'Example',","            'description' =&gt; 'Example module with UI samples',","            'class' =&gt; 'sb-app-info',","            'link' =&gt; pm_Context::getBaseUrl(),","        ),","        array(","            'title' =&gt; 'Modules',","            'description' =&gt; 'Modules installed in the Panel',","            'class' =&gt; 'sb-suspend',","            'link' =&gt; pm_Context::getModulesListUrl(),","        ),","    );","View:","    &lt;?php echo $this-&gt;renderSmallTools($this-&gt;smallTools); ?&gt;","renderTabs","Rendering of tabs.","Controller:","    $this-&gt;view-&gt;tabs = array(","        array(","            'title' =&gt; 'Form',","            'action' =&gt; 'form',","        ),","        array(","            'title' =&gt; 'Tools',","            'action' =&gt; 'tools',","        ),","        array(","            'title' =&gt; 'List',","            'action' =&gt; 'list',","        ),","    );","View:","    &lt;?php echo $this-&gt;renderTabs($this-&gt;tabs); ?&gt;","&nbsp;&nbsp;","Rendering UI Elements","73621.htm");
Page[28]=new Array("Extensions can advertise themselves by adding promotional blocks or widgets to the administrator's and customers' Home pages in Plesk. To use this feature, an extension must have a class that extends the pm_Promo_AdminHome class or pm_Promo_CustomerHome class and overrides the necessary class methods. All classes that extend pm_Promo_AdminHome and pm_Promo_CustomerHome are loaded when users navigate to the Home page. To be successfully displayed, an ancestor class must be properly named. Learn about the naming conventions in Class Naming Conventions.","Usage Example","The following code demonstrates an implementation of a promotional block.","    &lt;?php","     ","class Modules_MyModule_Promo_Home extends pm_Promo_AdminHome","{    ","    public function getTitle()","    {","        return 'Add Block Title Here';","    }","     ","    public function getText()","    {","        return 'Add your text here...';","    }","     ","    public function getButtonText()","    {","        return 'View';","    }","     ","    public function getButtonUrl()","    {","        return 'http://example.com';","    }","     ","    public function getIconUrl()","    {","        pm_Context::init('my-module');","        return pm_Context::getBaseUrl() . '/images/icon.png';","    }","}","&nbsp;","When you need to use the functions provided by the Extensions API, you need to define context in the method body by calling pm_Context::init('module ID'). ","The getButtonText and getIconUrl methods are optional. If you omit these methods, Plesk will use the default button caption and icon.","Plesk Home Page Widgets","71098.htm");
Page[29]=new Array("In your extension, you can adjust Plesk functionality and appearance by means of JavaScript and Cascading Style Sheets (CSS). These technologies enable you to do a variety of customizations to the Plesk interface, for example, adding new GUI elements and hiding existing ones. To make Plesk load your JavaScript or CSS code on every page of Plesk, put the code in the files global.css and global.js inside the /htdocs directory.","To load the code only on certain pages, use a construction like the following:","    if (&quot;/smb/file-manager/list&quot; != window.location.pathname) {","    	return;","    }","The Plesk's JavaScript framework is Prototype.","If you need to load additional libraries, you can do this directly in HTML, for example:","    $$(&quot;head&quot;).first().insert(","    	new Element(&quot;script&quot;, {type:&quot;text/javascript&quot;, src:&quot;//example.com/example.js&quot;})","    );","Global JavaScript and CSS Files","73254.htm");
Page[30]=new Array("Starting from Plesk 12, in addition to the ability to include global.js into pages (described in Global JavaScript and CSS Files), there is also the option to generate on the server side an additional HTML or JavaScript code for embedding into a page. To do this, you need to implement a class derived from pm_Hook_ContentInclude. The class must be located in the directory plib/hooks/.","The login page in Plesk does not include additional scripts that are used on other Plesk pages. To form additional content on the login page, you need to use the class pm_Hook_LoginContentInclude.","There are several ways to embed JavaScript. One of the easiest ways is to pass data from the server to the client (browser) by using the method getJsConfig:","    class Modules_EmbedJs_ContentInclude extends pm_Hook_ContentInclude","    {","     public function getJsConfig()","    {","        return [","            'dynamicVar' =&gt; date(DATE_ATOM),","        ];","    }","     ...","    }","The method must return an array which will be converted to JSON and embedded into a resulting HTML page, inside the HEAD tag.","    &lt;!-- extension include: embed-js --&gt;","    &lt;script&gt;","    //&lt;![CDATA[","        Jsw.namespace('PleskExt.EmbedJs');","    //]]&gt;","    &lt;/script&gt;","    &lt;script&gt;","    //&lt;![CDATA[","        PleskExt.EmbedJs.Config = {&quot;dynamicVar&quot;:&quot;2014-02-25T16:56:46+07:00&quot;};","    //]]&gt;","    &lt;/script&gt;","For access to the data formed on the server side, an extension called embed-js can use an object PleskExt.EmbedJs.Config. In addition to that, the namespace PleskExt.EmbedJs will be created.","There are also methods getJsContent and getJsOnReadyContent, which allow forming blocks of JavaScript code on the server side and adding it to the resulting HTML. The method getJsOnReadyContent executes JavaScript code after a DOM tree is fully loaded.","It is also possible to embed additional HTML content at the end of the HEAD and BODY tags. To do this, the methods getHeadContent and getBodyContent can be used. The following is an example of how to use these methods:","    class Modules_EmbedJs_ContentInclude extends pm_Hook_ContentInclude","    {","        public function getHeadContent()","        {","            return '&lt;!-- additional content for head tag --&gt;';","        }","     ","        public function getBodyContent()","        {","            return '&lt;!-- additional content for body tag --&gt;';","        }","    }","&nbsp;You can find the sample code in our repository here.","Content Include Hook","73622.htm");
Page[31]=new Array("The authentication hook allows checking for a username and password pair in an external system, for example, LDAP. To do this, you need to extend the class pm_Hook_Auth. The class must be located in the directory plib/hooks/.","The following is an example of such a hook:","    class Modules_MyExtension_Auth extends pm_Hook_Auth","    {","        public function auth($login, $password)","        {","            // TODO: add your implementation here","        }  ","    }","The method must return a boolean value. If a username and password pair is valid, it should return true.","You can control the operation of the extension during run-time by implementing the method isEnabled.","Authentication Hook","73623.htm");
Page[32]=new Array("Starting from Plesk 12.0, there is an easy way to add custom buttons related to an extension. Previously, extension developers had to use CLI or XML API calls in post-install and pre-uninstall scripts for creating custom buttons.","To add custom buttons, you need to develop a class derived from pm_Hook_CustomButtons. The class must be placed in the directory plib/hooks/. You can find the complete list of supported values for 'place' under 'Constants'.","The following example shows how to add several custom buttons:","    class Modules_CustomButtons_CustomButtons extends pm_Hook_CustomButtons","    {","     ","        public static function getButtons()","        {","            return [[","                'place' =&gt; self::PLACE_DOMAIN,","                'title' =&gt; 'Domain Button',","                'description' =&gt; 'Description for domain button',","                'icon' =&gt; pm_Context::getBaseUrl() . 'images/icon.png',","                'link' =&gt; pm_Context::getBaseUrl() . 'index.php/index/index',","            ], [","                'place' =&gt; [","                    self::PLACE_HOSTING_PANEL_NAVIGATION,","                    self::PLACE_ADMIN_TOOLS_AND_SETTINGS,","                    self::PLACE_RESELLER_TOOLS_AND_SETTINGS,","                ],","                'title' =&gt; 'Multi Place Button',","                'description' =&gt; 'Description for multi place button',","                'link' =&gt; 'http://odin.com/',","                'newWindow' =&gt; true,","            ]];","        }","     ","    }","You can set up custom buttons in the following places:","PLACE_COMMON","PLACE_ADMIN_HOME","PLACE_RESELLER_HOME","PLACE_CUSTOMER_HOME","PLACE_ADMIN_TOOLS_AND_SETTINGS","PLACE_RESELLER_TOOLS_AND_SETTINGS","PLACE_HOSTING_PANEL_NAVIGATION","PLACE_DOMAIN","PLACE_DOMAIN_PROPERTIES","PLACE_TOOLBAR","PLACE_LIST_ACTIONS","One button can be set up for multiple places at once. In some places, you can use such optional parameters as icon and description. You can specify both local and external hyperlinks.","You can find the sample code in our repository here.","Custom Buttons","73624.htm");
Page[33]=new Array("The system automatically displays extension messages in the language which Plesk currently uses if the extension has the corresponding translations. For example, if a customer uses the web interface in German, the extension also has the option to display its messages in German.","Extension messages are categorized into the following groups:","Meta information.<br>These messages are kept in the meta.xml file in the extension's root directory. To provide a translation of a node, specify the same node with a certain xml:lang attribute with a 4-letter language code conforming to RFC1766. For example:","&lt;description&gt;Easily add customers and websites&lt;/description&gt;","&lt;description  xml:lang=&quot;de-DE&quot;&gt;Einfache Neukundenerfassung &amp; simple Website-Erstellung&lt;/description&gt;","Other messages.<br>These messages are a part of the extension code, for example, form input captions, page titles, action names, etc. Next in this chapter you will learn how to help the system discover the translations to display them to Plesk users.","&nbsp;","The interface that allows for automatic message translation is called pm_Locale and it is presented by the corresponding class. To use this interface, you need:","Design the placeholders (keys) you will use instead of actual values in the GUI messages. For example, to substitute a button caption Accept, you may use acceptButtonText. A key can be an arbitrary string.<br>","Use pm_Locale::lmsg(key) instead of an actual string in the extension code. Here key can be acceptButtonText we obtained at step 1.<br>","Add language-dependent values for each key.","The key-value pairs must be included in the $messages associative array, for example:","&lt;?php","$messages = array(","    'acceptButtonText' =&gt; 'Accept',",");","A file which includes the $messages array must reside in &lt;product-root&gt;/plib/modules/&lt;module ID&gt;/resources/locales/ and its name must be equal to the corresponding 4-letter locale code. For example: de-DE.php. All messages corresponding to a certain language must be stored in a language-specific file. For example,","&lt;product-root&gt;/plib/modules/&lt;module ID&gt;/resources/locales/en-US.php:","&lt;?php","$messages = array(","    'acceptButtonText' =&gt; 'Accept',","    'cancelButtonText' =&gt; 'Cancel',",");","&lt;product-root&gt;/plib/modules/&lt;module ID&gt;/resources/locales/de-DE.php:","&lt;?php","$messages = array(","    'acceptButtonText' =&gt; 'Accept',","    'cancelButtonText' =&gt; 'Stornieren',",");","To retrieve the currently used interface language, you can use the getCode method.","The following example shows the contents of an English locale file for a module with the code panel-news, which is located in the file /usr/local/psa/admin/plib/modules/panel-news/resources/locales/en-US.php.","&lt;?php","     ","$messages = array(","    'blockTitle' =&gt; 'Plesk News',","    'buttonTitle' =&gt; 'View Article',",");","Localization","71107.htm");
Page[34]=new Array("To test your extension in real-life conditions, install it to Plesk by logging in to Plesk as the administrator and adding the extension on the Server Management &gt; Extensions page. Below you will find Plesk configuration parameters that help you easily debug your extensions. Be sure to comment the parameters (by adding the leading ; symbol) after you complete testing and decide to use Plesk in production.","How to Improve the Verbosity of Debug Information   ","If your extension uses the Plesk GUI and it exits with an error or an exception, you should see the PHP stack trace. If you do not see it, and, say, see only a blank screen, try to improve the verbosity level of the debug output by adding a few lines to panel.ini. The file path is: ","(Linux) /usr/local/psa/admin/conf/panel.ini","(Windows) %plesk_dir%\\admin\\conf\\panel.ini","If you do not have this file, create it.","Open the file and add the following lines to it:","[log]","priority=7","&nbsp;","Then, turn on PHP error reporting in php.ini. The file path is:","(Linux) /usr/local/psa/admin/conf/php.ini","(Windows) %plesk_dir%\\admin\\conf\\php.ini","Open the file and edit the display_errors setting:","display_errors = On","&nbsp;","Restart the the web server which handles requests to the Plesk GUI:","/etc/init.d/sw-cp-server restart","How to Prevent Inconsistency Between Code and Results","If you are testing an extension on Linux, you may run across the problem with inconsistency between your code and expected result. The inconsistency happens because Plesk content is cached, so the cache must expire before you see the update. To mitigate this problem, turn the Plesk cache off. This is also triggered in php.ini by the following line:","apc.enabled = 0","The change will take effect after you restart the web server which handles requests to the Plesk GUI. The restart command is as follows:","/etc/init.d/sw-cp-server restart","&nbsp;&nbsp;","Testing Extensions","71114.htm");
Page[35]=new Array("Handler is an executable file which is invoked at selected points (called hooking points). ","Mail handlers are used to handle incoming, outgoing, and pass-through mail at various stages of processing by the Mail Transfer Agent (MTA). One or more handlers can be applied to a message.","Note: Every handler you use should be registered with the mail_handlers_control utility. For details, refer to the Managing Handlers section.","Mail Handlers","71844.htm");
Page[36]=new Array("A handler can be invoked at the hooking points described below.","Before queuing","Handlers can be called before the message is placed in the MTA queue. If this is a message being received by SMTP, the handlers are called synchronously during the SMTP session.","At this point, the message can have multiple recipients listed in the envelope. The handler can only take actions upon the message as whole, i.e. it cannot, for example, reject the message for some recipients while accepting it for the others.","Before local delivery","These handlers are called after reading a message from the MTA queue and deciding to deliver it to a local recipient. Note that messages to nonexistent local addresses are handled, too.","At this point, the message has exactly one recipient. Messages directed to multiple local recipients are split at an earlier stage. The handler can take actions upon the message directed to one recipient without affecting sibling messages directed to other local recipients.","Before remote delivery","These handlers are called after reading a message from the MTA queue and deciding to deliver it to a remote host.","At this point, the message can have multiple recipients. This happens only when the message is to be delivered to the same host for all of these recipients. If the message has multiple recipients for which remote delivery to different hosts is needed, such a message is split at an earlier stage. ","Before SMTP data","These handlers are called after the envelop is sent, but before sending the body of a message (before the DATA command of SMTP protocol). Used by services that process only the messages headers, not their content.","Hooking Points","71845.htm");
Page[37]=new Array("The handler is invoked as follows:","# ./handler context sender recipient [recipient]...[recipient]","Handlers are not intended to be invoked by users, and they don't follow the getopt conventions.&nbsp;","Arguments","context","An arbitrary string specified during the handler registration. Useful if the same executable file is being used for several handling purposes or in several modes. ","sender","The sender address. Note that the sender address is an empty string in case of bounce messages: The command line argument will be empty while still occupying a position in the argument list. ","recipient","The recipient address. The order in which the recipients are listed is undefined. There is exactly one recipient address when a handler is called before local delivery, and there is one or more recipient addresses at other hooking points. ","Command Line","71847.htm");
Page[38]=new Array("This process consists of three parts: message data is read by a handler from the standard input, processed by the handler, and the result of the operation is written to the standard output.","Processing Messages","71848.htm");
Page[39]=new Array("The message is fed to the handler on the standard input. The handler should not expect the standard input to be seekable.","The input contains the message headers, an empty line, and the message body. The message ends when end-of-stream is encountered. The envelope information is not included here.","Lines are separated by bare LF in the message.","Message Input","71848.htm#o71849");
Page[40]=new Array("The handler is expected to produce the following output on standard error:","PASS ","The message should be passed further. The handler should write the message, possibly modified, on the standard output.","STOP ","The message should not be passed further and this is not an error. This should be used when the handler implements its own custom delivery instead of the delivery provided by the MTA. Subsequent handlers won't be called.","DEFER","The message should not be passed further. A temporary error condition should be indicated. Subsequent handlers won't be called.","REJECT","The message should not be passed further. A permanent error condition should be indicated. Subsequent handlers won't be called.","LOG text ","The line of text should be treated as a warning or error message and added to the appropriate log.","SKIP ","The handler should not process and pass the message to the handler's output. The message should be passed further without any modifications.","&nbsp;","Each line of output on the standard error should be terminated with LF. After the first PASS, STOP, DEFER, REJECT, or SKIP line, further output is not accepted, so any LOG lines must precede the above. ","The exit code from the handler should be 0 on PASS or STOP and not 0 in other cases.","Handler Output","71848.htm#o71850");
Page[41]=new Array("The handler should only write to its standard output after writing PASS or REJECT on the standard error.","For PASS, the output should be a message in the same format as found on input.","Message Output","71848.htm#o71851");
Page[42]=new Array("The exit code from the handler should be 0 on PASS or STOP and not 0 in other cases. ","Exit Code","71848.htm#o71852");
Page[43]=new Array("The handler will be invoked with the rights defined for its owner, regardless of those rights with which MTA is running. If specific rights for file system access are required, the handler should be given the SETUID bit.","The current working directory is undefined.","Most environment variables are removed, only the essential ones are left: PATH and LANG. The latter will be set to the value C. ","Invocation Context","71848.htm#o71853");
Page[44]=new Array("Handlers can be viewed and managed - registered, enabled/disabled, or removed - with the mail_handlers_control utility located in the /usr/local/psa/admin/bin directory on the Plesk server (Linux). ","Note: We do not recommend usage of the obsolete mailmng utility.","The utility uses the following syntax:","# ./mail_handlers_control [parameters] [options]","The mail_handlers_control utility stores information about registered handlers in the SQLite database, which is then accessed by the patched MTA or an add-on to MTA.","A handler can be registered to be called in the following situations:","For all messages.","For messages having specific sender or recipient address.","For messages having specific sender or recipient domain part of the address.","For matching addresses, simple case-insensitive string comparison is done. It does not matter whether the specified domains or mail accounts exist in Plesk.","The executable file specified for the handler must exist. If it does not exist, or is not executable, the handler is not called. The core is allowed to automatically remove handlers whose executable files do not exist, but it must not remove handlers whose files exist but are not executable. &nbsp;","Managing Handlers","71854.htm");
Page[45]=new Array("To register a handler, run the following command:","# ./mail_handlers_control --add ","                --priority=&lt;number&gt;","                --name=&lt;handler name&gt;","                --mailname=&lt;mailname&gt;","                --queue=&lt;before-local|before-remote|before-queue|before-data&gt;","                --type=&lt;sender|recipient|sender-domain|recipient-domain|global&gt;","                --executable=&lt;executable file&gt;","                [ --context=&lt;context&gt; ]","                [ --enabled ]","The arguments are explained in the following table.","Argument","Definition","--name","Specifies the handler name. The string is allowed to contain any character allowed in UNIX file name (that is, anything except slash and NUL). Registration will fail if a handler with the specified name has already been registered.","--type","Specifies the type of a handler, may take the following values:","global    <br>handler is called for all messages. ","sender-domain<br>handler is called for messages whenever the domain part of the sender address matches the specified domain","recipient-domain<br>handler is called for messages whenever the domain part of one of the recipient addresses matches the specified domain","sender<br>handler is called for messages whenever the sender address matches the specified address","recipient<br>handler is called for messages whenever any of the recipient addresses matches the specified address","--mailname","Specifies a domain or a mail address for the handler-type.","Not required if the handler type is global.","--priority","Specifies the hook priority in the queue of hooks. ","--executable","Specifies the handler executable file. ","Registration will fail if the file does not exist.","--context","Specifies the context. This is an opaque string to be passed to the handler on the command line.","--enabled","Specifies whether to enable the handler.","--queue","Specifies the hooking point. Should be one of: before-queue, before-local, before-remote, before-data.","See Hooking Points for details.","&nbsp;","The following handler is added to filter correspondence before local delivery:","# ./mail_handlers_control --add","    --name=1my_handler-ld","    --type=sender","    --mailname=myema@example.com","    --executable=/usr/local/bin/my_handler.sh","    --context='context'","    --queue=before-local","    --priority=33","    --enabled","Registering Mail Handlers","71855.htm");
Page[46]=new Array("To view registered handlers, run the following command:","# ./mail_handlers_control --list ","    [ --mailname=&lt;mailname&gt; | --global ]","    [ --extent ]","The --list command has optional parameters:","The extent parameter allows viewing additional information about handlers - the context and the full path to the executable file of the handler. ","The global parameter allows viewing only handlers of the global type. The mailname parameter shows the handlers registered for the specified domain or email address.","Viewing Mail Handlers","71856.htm");
Page[47]=new Array("To remove a handler, run the following command:","# ./mail_handlers_control --remove","    --name=&lt;name&gt; ","    --type=&lt;global|sender-domain|sender|recipient-domain|recipient&gt; ","    --queue=&lt;before-queue|before-local|before-remote|before-data&gt; ","    [ --mailname=&lt;mailname&gt; ]","Removing Mail Handlers","71857.htm");
Page[48]=new Array("To disable a handler, run the following command:","# ./mail_handlers_control --disable ","    --name=&lt;handler name&gt; ","    --type=&lt;sender|recipient|sender-domain|recipient-domain|global&gt; ","    --queue=&lt;before-queue|before-local|before-remote|before-data&gt; ","    [ --mailname=&lt;mailname&gt; ]","This command removes the handler from the queue (defined by --queue) and leaves all the data associated with the handler in the database.","&nbsp;","To enable a handler, run the following command:","# ./mail_handlers_control --enable  ","    --name=&lt;handler name&gt; ","    --type=&lt;sender|recipient|sender-domain|recipient-domain|global&gt; ","    --queue=&lt;before-queue|before-local|before-remote|before-data&gt; ","    [ --mailname=&lt;mailname&gt; ]","This command adds the handler to the queue (defined in --queue) basing on the handler data remaining in the database.","Disabling/Enabling Mail Handlers","71858.htm");
Page[49]=new Array("The information about the registered handlers is stored in the SQLite database handlers.db, which is located in /var/lib/plesk/mail/handlers/. The registration of the handler means that MTA will use it to filter mail.","For the gMail MTA, the code which invokes handlers is either patched into qmail or installed as wrappers around qmail-queue, qmail-local, and qmail-remote.","For the Postfix MTA, the code which invokes handlers is executed via the specific Milter service psa-pc-remote.","Implementation Notes","71859.htm");
Page[50]=new Array("By default, a Plesk server acts as a master DNS server for websites hosted on it. Alternatively, you can use external third-party DNS services to resolve domain names hosted in Plesk, for example, Amazon Route 53 (http://aws.amazon.com/route53/), DynECT (http://dyn.com/dns/dynect-managed-dns/), or Godaddy Premium DNS (http://www.godaddy.com/domains/dns-hosting.aspx). Using such services has certain advantages:","Reduced load on your Plesk server.","Improved DNS hosting reliability.","If you plan to use an external third-party DNS service, you can configure your Plesk so that it uses this service instead of its own DNS server. This will not affect website owners: From their perspective, Plesk stays a master DNS server for their domains.","To make your Plesk automatically provision DNS zones to a third-party DNS, you should write an integration script.","DNS Integration Script","The integration script is a script (written in any language supported by your server) that propagates changes made to DNS zones in Plesk UI to the selected third-party DNS service.  The script should communicate with the external service by means of the service's API.","After you register the script in Plesk, the latter will pass to the script information about any change in DNS zones, for example, adding or removing resource records or entire zones.","The script must meet the following requirements:","It should be able to process the input parameters given in the table below.","If the actions are completed successfully, the script should return errorcode0.","If you want your script to write information about its execution to Plesk log files, send this information to the script's stdout and sterr.","An example of the script that integrates Plesk with the Amazon Route 53 is available on our GitHub page.","Note that to use this script, you should take two steps:","Download the library for working with Amazon Web Services in PHP - aws.phar from http://aws.amazon.com/sdkforphp/ and place it in the same directory with the script.","Specify your Amazon security credentials in the script (lines 23 and 24):","    'client' =&gt; array(","        'key' =&gt; '&lt;key&gt;',","        'secret' =&gt; '&lt;secret&gt;',","    ),","Integration Script Input Parameters","Note: All parameters are of the string type.","Parameter","Description","Example","command","The operation that should be performed on the specified zone (create, update, or delete) or reverse (PTR) record (createPTRs or deletePTRs)","create","zone","Information about the zone on which the operation is performed. Provided if the command is create, update, or delete","name","The name of the zone.","d10.tld.","displayName","The name of the zone without IDN to ASCII conversion.","d10.tld.","soa","Information about the SOA resource record in the zone. Provided if the command is create.","email","Contact email","domainowner@samplemail.com","status","Always 0.","0","type","Type of the DNS server. Always master.","master","ttl","The amount of time in seconds that other DNS servers should store the record in a cache.","86400","refresh","Time in seconds how often the secondary name servers check with the primary name server to see if any changes have been made to the domain's zone file.","10800","retry","Time in seconds a secondary server waits before retrying a failed zone transfer.","3600","expire","Time in seconds before a secondary server stops responding to queries, after a lapsed refresh interval where the zone was not refreshed or updated.","604800","minimum","Time in seconds a secondary server should cache a negative response","10800","serial","The number that identifies the state of the zone. Plesk uses the Unix time stamp of the moment when the request is sent.","1363228965","serial_format","Always &quot;UNIXTIMESTAMP&quot;","rr","Information about resource records within the specified zone. Provided if the command is create or update.","host","The host name of a node within the zone.","www.d10.tld.","displayHost","The host name of a node without IDN to ASCII conversion.","www.d10.tld.","type","The type of the record.","CNAME","opt","The part of the value without IP or hostname.","value","A value (IP address of host name) of the resource that will be available on the specified host.","d10.tld.","displayValue","A value (IP address of host name) of the resource that will be available on the specified hostwithout IDN to ASCII conversion.","d10.tld.","ptr","Information about the reverse (PTR) records. Provided if the command is createPTRs or deletePTRs.","ip_address","The reverse record's IP address. May be IPv4 or IPv6 address.","10.52.59.29","hostname","The reverse record's host name.","d10.tld","Integrating Plesk with a Third-Party DNS","To switch on Plesk integration with third-party DNS:","Put your integration script into your extension's /plib/scripts/ directory. For example: /plib/scripts/route53.php.","Make sure that your script can be executed successfully from command line:","On Linux: plesk bin extension --exec &lt;extension_id&gt; &lt;script_name&gt;","On Windows: &lt;plesk_dir&gt;\\bin\\extension.exe --exec &lt;extension_id&gt; &lt;script_name&gt;","For example: plesk bin extension --exec route53 route53.php","Setup post-install.php script to register custom DNS backend with the following command line utility:","On Linux: plesk bin server_dns --enable-custom-backend &lt;script_execution&gt;","On Windows: &lt;plesk_dir&gt;\\bin\\server_dns.exe --enable-custom-backend &lt;script_execution&gt;","For example:","$script = 'plesk bin extension --exec route53 route53.php';","$result = pm_ApiCli::call('server_dns', ['--enable-custom-backend', $script]);","To switch off Plesk integration with third-party DNS and restore the default settings:","Setup the pre-uninstall.php script to disable custom DNS backend with the following command line utility:","On Linux: plesk bin server_dns --disable-custom-backend","On Windows: &lt;plesk_dir&gt;\\bin\\server_dns.exe --disable-custom-backend","For example:","$result = pm_ApiCli::call('server_dns', ['--disable-custom-backend']);","You can find a complete example of the integration on github: https://github.com/plesk/ext-route53","Integration with Third-Party DNS Services","72158.htm");
Page[51]=new Array("This chapter describes how to integrate Plesk with an external Linux-based slave DNS server.","The integration can be performed using the Slave DNS Manager extension available in the Extensions Catalog in the Plesk GUI.","The extension works according to the following algorithm:","It registers a slave server in the extension settings.","The slave server&#8217;s IP address is automatically added to the list of addresses allowed to transfer domain zones from the Plesk server.","When you create, modify, or delete an active domain zone in Plesk, Plesk creates, modifies, or deletes the domain zone in the local DNS service.","The script starts and receives the domain name and the command to create, modify, or delete a domain zone.","The script initiates the rndc command for each connected slave server.","Slave servers synchronize domain zones with the ones on the Plesk server.","Note: The following instructions are intended for Debian Linux. The sequence of steps on other Linux systems is the same; however, commands, and paths to configuration files might be different.","To set up a slave DNS server, do the following:","Install BIND.","apt-get install bind9","Allow creating new zones with rndc. In the /etc/bind/named.conf.options file, in the options {} directive, type allow-new-zones yes;","Specify the IP address from which control instructions should be accepted and set BIND to listen on all accessible network interfaces. In the /etc/bind/named.conf.local file, type:","controls {","	inet * port 953 allow { &lt;plesk_ip&gt;; &lt;another_plesk_ip&gt; 127.0.0.1; };"," };","Restart the BIND service by issuing the following command:","invoke-rc.d bind9 restart","Be sure to remember the secret key located in the /etc/bind/rndc.key file:","key &#8220;rndc-key&#8221; {","	algorithm hmac-md5;","	secret &quot;vwOxonI4n4CVRUhKAOAAIA==&quot;;"," };","That&#8217;s it, the slave name server is set up.","After that, install the extension on the Plesk server. In the extension settings, add the slave server and specify its IP address and the secret key. The extension will create a configuration file with the slave server settings for the rndc utility. From now on, Plesk will automatically transfer all created, modified, and deleted zones to the slave server by executing the following commands for each slave server:","# Creation","/usr/sbin/rndc -c slave.config addzone example.com '{ type slave; file &quot;/var/lib/bind/example.com&quot;; masters { &lt;plesk_ip&gt;; }; };'","# Modification","/usr/sbin/rndc -c slave.config refresh example.com","# Deletion","/usr/sbin/rndc -c slave.config delzone example.com","Now, when you add a domain in Plesk, a DNS zone is automatically created on the slave server as well as on the master server.","Setting Up a Slave DNS Server","73349.htm");
Page[52]=new Array("For developers' convenience, we have created several extension examples. They might help you understand how to develop certain functionality. Before implementing certain aspects of an extension, we recommend that you familiarize yourself with examples and their code. A task that you need to accomplish might be a typical one, and there is a chance that there is a ready implementation example that will help you speed up development.","The extension examples can be found on our GitHub page. You can install them into Plesk by using the Plesk administrator's interface.","Panel Stats","The extension enables external or third-party systems to retrieve statistics about Plesk usage. It is possible to retrieve data at a special URL. The data include information about the number of subscriptions, domains, customers, and resellers. The information can be presented in various formats. This extension can be useful for integration with external monitoring and statistics calculation systems.","The following techniques are demonstrated:","Provision of information.","Authentication mechanism.","The use of the XML API to retrieve statistical data.","The use of a key-value storage for keeping the extension's settings.","Creation and processing of a page with a settings form.","Generation of default settings in the post-install script.","Panel News","The extension is a widget for the administrator's Home page in Plesk. It shows the latest news about Plesk (based on an RSS channel). The RSS feed is updated daily.","The following techniques are demonstrated:","Addition of a widget to the administrator's Home page.","Periodic data update based on a task scheduler.","The use of a key-value storage for keeping the extension's data.","Retrieval of initial data in the post-install script and task scheduling.","Requests Tracker","The extension adds a request tracking system, which customers can use to file requests to the Plesk administrator. The administrator can comment on request tickets and close them.","The following techniques are demonstrated:","Creation of a web interface for an extension.","Addition of buttons for the administrator and customers.","Rendering of different interfaces for the administrator and customers.","The use of the post-install script.","The use of an SQLite database for storing information.","Module Example","A test extension intended to demonstrate various aspects of using the API.","The following techniques are demonstrated:","Creation of a custom button in the post-install script.","Creation of an interface by using MVC.","Creation of a form.","There are a number of other sample extensions available in our GitHub repository here. Look for the repositories with the ext- prefix, for example, ext-embed-js.","Extension Examples","73625.htm");
var PageCount=53;

function search(SearchWord){
var Result="";
var NrRes=0;
Result='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">\n';
Result+="<html>\n";
Result+="<head>\n";
Result+="<title>Search Results</title>\n";
Result+="<meta http-equiv='Content-Type' content='text/html; charset=UTF-8'>\n";
Result+='<script language="javascript" type="text/javascript" charset="UTF-8" src="dhtml_search.js"></script>\n';
Result+='<link rel="stylesheet" type="text/css" href="stylesheet.css">\n';
Result+="</head>\n";
Result+="<body onload='javascript:document.SearchForm.SearchText.focus()'>\n";


/* old */ /*

Result+='<p class="searchDetails">Enter a keyword or phrase';

Result+='<form name="SearchForm" action="javascript:search(document.SearchForm.SearchText.value)">';
if(SearchWord.length>=1){
   while(SearchWord.indexOf("<")>-1 || SearchWord.indexOf(">")>-1 || SearchWord.indexOf('"')>-1){
       SearchWord=SearchWord.replace("<","&lt;").replace(">","&gt;").replace('"',"&quot;");
   }
}
Result+='<input type="text" name="SearchText" size="25" value="' + SearchWord + '" />';
Result+='&nbsp;<input type="submit" value="&nbsp;go&nbsp;"/></form>';
Result+='</p>\n';

*/ /* new */


Result+='<form name="SearchForm" action="javascript:search(document.SearchForm.SearchText.value)">';
Result+='<p class="searchDetails">Enter a keyword or phrase';

if(SearchWord.length>=1){
   while(SearchWord.indexOf("<")>-1 || SearchWord.indexOf(">")>-1 || SearchWord.indexOf('"')>-1){
       SearchWord=SearchWord.replace("<","&lt;").replace(">","&gt;").replace('"',"&quot;");
   }
}

Result+='<input type="text" name="SearchText" class="inputText" value="' + SearchWord + '" />';
Result+='&nbsp;<input type="submit" value="&nbsp;go&nbsp;"/>';
Result+='</p>\n';
Result+='</form>\n';

/* end */



if(SearchWord.length>=1){
   SearchWord=SearchWord.toLowerCase();
   this.status="Searching, please wait...";
   Result+="<table border='0' cellpadding='0' cellspacing='0' class='tocTable' width='90%'>";

   for(j=0;j<PageCount;j++){
       k=Page[j].length-1;
       for(i=0;i<k;i++){
           WordPos=Page[j][i].toLowerCase().indexOf(SearchWord);
           if(WordPos>-1){
                NrRes++;
               break; }}}

   Result+="<tr><td class='search'><p class='searchFound'>" + NrRes + " results found</p></td></tr>";

   for(j=0;j<PageCount;j++){
       k=Page[j].length-1;
       for(i=0;i<k;i++){
           WordPos=Page[j][i].toLowerCase().indexOf(SearchWord);
           if(WordPos>-1){

               FoundWord=Page[j][i].substr(WordPos,SearchWord.length);
               NrRes++;
               Result+="<tr><td class='search'><p class='searchResults'>";
               Result+="<a target='BODY' href='"+Page[j][k]+"'>"+Page[j][k-1].replace(FoundWord,"<span class='searchFoundWord'>"+FoundWord+"</span>")+"</a><br/>\n";

               if(i<k-1){
                   if(Page[j][i].length>350){
                       Result+="..."+Page[j][i].substr(WordPos-100,200+FoundWord.length).replace(FoundWord,"<span class='searchFoundWord'>"+FoundWord+"</span>")+"...\n";
                   }
                   else{
                       Result+=Page[j][i].replace(FoundWord,"<span class='searchFoundWord'>"+FoundWord+"</span>")+"\n";
                   }
               }
               Result+="</p></td></tr>";
               break;			   
           }		   
       }	   
   }
     
   Result+="</table>";
   

}

Result+="</body></html>";
this.status="";
this.document.open();
this.document.write(Result);
this.document.close();
}//